# OMSens

OpenModelica sensitivity analysis and optimization module.

## Dependencies

  - [OpenModelica](https://github.com/OpenModelica/OpenModelica)
  - [Python >= 3.6](https://www.python.org/)
  - [Python setuptools](https://pypi.org/project/setuptools/)

## Supported platforms

  - Windows
  - Linux

## Build/Install instructions

Follow the instructions matching your OS:

  - [OMCompiler/README.Linux.md](https://github.com/OpenModelica/OpenModelica/blob/master/OMCompiler/README.Linux.md)
  - [OMCompiler/README.Windows.md](https://github.com/OpenModelica/OpenModelica/blob/master/OMCompiler/README.Windows.md)

### Windows MSYS Makefiles

If you used MSYS Makefiles to compile OpenModelica you need one additional step:

Start a MSYS terminal `$OMDEV\tools\msys\mingw64.exe` (64 bit) or
`$OMDEV\tools\msys\mingw32.exe` (32 bit) and run:

```bash
$ cd /path/to/OpenModelica
make -f Makefile.omdev.mingw omsens -j<Nr. of cores>
```

### Linux

Install the dependencies mentioned above and then run the following commands in the `terminal`.

```bash
$ cd /path/to/OpenModelica/OMSens
$ python setup.py install
```

**Hint**: To find the installation path run `OMEdit` and then go to `Help->About OMEdit`.

## Bug Reports

  - Submit bugs through the [OpenModelica GitHub issues](https://github.com/OpenModelica/OpenModelica/issues/new).
  - [Pull requests](../../pulls) are welcome ❤️

c     Usage:  call fu(n,x,f)
c         n:  dimension of x.
c         x:  n-dimensional vector.
c         f:  value of the function at the point x.    ! Ale: fx en nugrad
c
c         n:  dimension of the problem.
c
c        x0:  initial guess point.
c
c       eps:  tolerance for the stopping criterion.
c
c    ibound:  parameter such that if equal to
c             0 is an unconstrained problem
c             1 is a constrained problem.
c
c    jbound:  working vector of dimension n defining the sort of
c             constraint for each variable (only used when ibound.ne.0).
c             jbound(i) = 0 if the ith variable has no constraints.
c                         1 if the ith variable has only upper bounds.
c                         2 if the ith variable has only lower bounds.
c                         3 if the ith variable has both upper and
c                           lower bounds.
c
c        bl:  vector of lower bounds (not used if ibound=0).
c
c        bu:  vector of upper bounds (not used if ibound=0).
c
c        wa:  working vector of dimension (see output)
c             9*n+n*(n+1)/2+n*n+max(7*n-n*(n+1)/2,0)
c
c       nfu:  maximum number of function evaluations. If equal to
c             zero, the default value of 5000*n is used.
c
c     idiff:  Choose forward or central differences.  Forward
c            differences require fewer function evaluations and
c             should be favored unless the problem is exceedingly
c             difficult.
c             idiff = 1  forward differences
c             idiff = 2  central differences
c
c     kmax:   The parameter kmax is such that the hessian is
c             recomputed every kmax iterations.
c             We recommend kmax = 3 unless the problem is
c             very difficult.  In this case choose kmax = 1 or 2.
      program main
        use testData
        implicit none
      CHARACTER(LEN=500) :: infile_path,tests_path,file_name,
     * raw_infile_path, raw_outfile_path, outfile_path
      integer i, ibound, nfu, idiff, kmax, nit, ier,argsize
      integer output_id
      double precision eps
      external objectiveFunction

      ! Define which test to run

      ! Read test to run from command line
      CALL getarg(1, raw_infile_path)
      argsize = LEN_TRIM(raw_infile_path)
      IF(argsize .EQ. 0) call exitWithError("Invalid input command line
     * arguments. Should be two: input file and output file
     *Example: tests/test_01.txt tmp/output.csv")
      infile_path = TRIM(raw_infile_path)
      ! Read output file path from command line
      CALL getarg(2, raw_outfile_path)
      argsize = LEN_TRIM(raw_outfile_path)
      IF(argsize .EQ. 0) call exitWithError("Invalid input command line
     * arguments. Should be two: input file and output file
     *Example: tests/test_01.txt tmp/output.csv")
      outfile_path = TRIM(raw_outfile_path)

      ! Hardcode the test to run
!      tests_path = "tests/"
!      file_name = "test_01.txt"
!      !file_name = "test_10.txt"
!      infile_path = trim(tests_path) // trim(file_name)

      ! Read test file
      call readTest(infile_path)

      ! Initialize CURVI inputs that are used with the same value for every test
      eps=1.d-10    ! tolerance for the stopping criterion.
      ibound=1      ! 1 if constrained problem
      nfu=0         ! max number of calls to fu
      idiff=2       ! idiff = 2  central differences
      kmax=3        ! hessian is recomputed after kmax iterations
      DO i=1,nparams
        jbound(i)=3      ! 3 if the ith variable has both upper and lower bounds
      end do

      ! Call curvi:
      call curvif(objectiveFunction, ! fu
     * nparams,                      ! n
     * params_values,                ! x0
     * fopt,                         ! fopt
     * eps,
     * ibound,
     * jbound,
     * bl,
     * bu,
     * wa,
     * nfu,
     * nit,
     * idiff,
     * kmax,
     * ier)

      ! Open output file to output_id
      output_id = 555
      open(output_id,file=outfile_path)
      ! Write header
      write(output_id,"(A)")'"Parameter_name", "Parameter_value"'
      ! Write values for each parameter
      do i=1,nparams
        write(output_id,"(9999(A,',',G12.5))")trim(params_names(i)),
     * params_values(i)
      end do
      ! Log to stdout that we wrote the result
      write(*,*)" Wrote optimal parameter values to ",trim(outfile_path)

      ! Deallocate everything and exit
      deallocate(params_names)
      deallocate(params_values)
      deallocate(bl)
      deallocate(bu)
      deallocate(jbound)
      deallocate(wa)
      deallocate(target_vars)

C  Curvi single variable cost function using only population:
!      call test01()  ! only nr_resources_init
C      call test02()
C      call test03()  !relative top12 for 5% and modifying here 5%
C      call test04()  !relative top12 for 5% and modifying here 1%
C      call test05()  !perturb all of the params by max of +-1%   (ran for a day and didn't finish)
C      call test06()     !relative top18 (>1% effect) for 5% and modifying here 3%
C      call test07()     !relative no influencers curvi 5%
C      call test08()     !relative top36 (>0.1% effect) for 5% and modifying here 3%
C      call test09()     ! only measurable initial values (initial values of variables that model the real life) curvi 3%
C      call test10()     ! only measurable initial values (initial values of variables that model the real life) curvi 5%
C  Curvi multi variable cost function:
C      call test23()     ! equivalent to test 03 but also taking into account hwi alongside pop
C      call test24()     ! SIMILAR to test 04 but 3% INSTEAD OF 1% also taking into account hwi alongside pop
C      call test26()     ! equivalent to test 06 but also taking into account hwi alongside pop
C Using ZXPOWL:
C      call test11()   ! equivalent to test01 but zxpowl instead of curvi
C      call test16()   ! equivalent to test06 but zxpowl instead of curvi
C Trying to maximize only hdi:
C      call test31()   ! the parameters are the policy triggers for scenarios 2 to 9. Initial: 2050
C      call test32()   ! the parameters are the policy triggers for scenarios 2 to 9. Initial: 2018
C      call test33()   ! the parameters are the policy triggers for scenarios 2 to 9. Initial: 2034

C BORRAR :
C      DOUBLE PRECISION params_values(1),x(1)
C      DOUBLE PRECISION f
C      params_values = (/1000000000000.0D0/)      !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
C      x = params_values
C      n = 1
C       call fu_test10(n,x,f)
C BORRAR ^
      end program

      subroutine objectiveFunction(n,x,f)
        use testData ! where we get the common vars
        implicit none
      DOUBLE PRECISION x(n), res_vars_values(1), f
      integer n

      call w3Wrapper(stopTime,
     * params_names,x,target_vars,nparams,
     * ntarget_vars,res_vars_values)
      !  For now the objective function allows only one output variable
      !  and it tries to maximize it (by negating it as CURVI is a
      !  minimizer). An example of a more complex objective function
      !  could be: "f = -(res_vars_values(1)/1D10 + res_vars_values(2))",
      !  that uses 2 variables instead of one.
      f = -res_vars_values(1)
      write(*,*) "Objective function value:"
      write(*,*) f
      return
      end subroutine objectiveFunction



C .--------------------------------------------------------------------------------- DESCOMENTAR:

C--------------- Test01 -----------------
      subroutine test01()
      DOUBLE PRECISION params_values(1)
      dimension jbound(1)
      DOUBLE PRECISION bl(1),bu(1),x0(1),wa(17),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test01

        write(*,*) "Inside test01 at date:"
        call system("date")
      params_values = (/1000000000000.0D0/)      !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 1
      eps=1.d-10
      ibound=1
      jbound(1)=3      ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
C      jbound(2)=3
      bl(1)=1000D0     ! lower bound of x0(1) (depends on ibound and jbound)
C      bl(2)=-3.d0
      bu(1)=2000000000000.0D0    ! upper bound of x0(1)  (depends on ibound and jbound)
C      bu(2)=3.d0
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test01, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)x0(1)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test01 at date:"
        call system("date")
      end subroutine test01
C Test01: fu
      subroutine fu_test01(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      integer nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f

      nvars = 1
      stopTime = 2100
      params_names = (/"nr_resources_init"/)    !careful! you have to change the list length on top if you add or remove a parameter
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine
C--------------- Test02 -----------------
C# Hugo Scolnik article: "Crítica metodológica al modelo WORLD 3" (Methodological criticisim to the World3 model)
C#   Perturbed 5 params by 5%
C      # ICOR= 3.15, Default: ICOR=3
C      # ALIC= 13.3, Default: ALIC=14
C      # ALSC= 17.1, Default: ALSC=20
C      # SCOR= 1.05, Default: SCOR=1
C      # Run "Perturbed": FFW= 0.231, Default: FFW=0.22
C      # Run "Perturbed Increasing FFW": FFW= 0.242, Default: FFW=0.22
C#   Perturbed rest of the params by a scalar of 0.24172080E-12
C In this test:
C    We run the function trying to maximize the population by perturbing ICOR(p_ind_cap_out_ratio_1), ALIC(p_avg_life_ind_cap_1), ALSC(p_avg_life_serv_cap_1) and SCOR(p_serv_cap_out_ratio_1).

      subroutine test02()
      DOUBLE PRECISION params_values(4)
      dimension jbound(4)
      DOUBLE PRECISION bl(4),bu(4),x0(4),wa(80),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test02
C p_ind_cap_out_ratio_1,3
        write(*,*) "Inside test02 at date:"
        call system("date")
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1
      params_values = (/3D0,14D0,20D0,1D0/)      !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 4
      eps=1.d-10
      ibound=1
      jbound(1)=3      ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      jbound(2)=3
      jbound(3)=3
      jbound(4)=3
C Lower bounds: -5% than default
      bl(1)= 2.85        ! lower bound of x0(1) (depends on ibound and jbound)
      bl(2)= 13.3
      bl(3)= 19.0
      bl(4)= 0.95
C Upper bounds: +5% than default
      bu(1)= 3.15        ! upper bound of x0(1) (depends on ibound and jbound)
      bu(2)= 14.7
      bu(3)= 21
      bu(4)= 1.05

      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test02, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)x0(1),x0(2),x0(3),x0(4)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test02 at date:"
        call system("date")
      end subroutine test02
C Test02: fu
      subroutine fu_test02(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(4), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      integer nvars
      DOUBLE PRECISION x(4)
      DOUBLE PRECISION res_vars_values(1), params_values(4),f
      write(*,*) "*** Inside fu_test02!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
      params_names(1)  = "p_ind_cap_out_ratio_1"
      params_names(2)  = "p_avg_life_ind_cap_1"
      params_names(3)  = "p_avg_life_serv_cap_1"
      params_names(4)  = "p_serv_cap_out_ratio_1"
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine


C--------------- Test03 -----------------
C This test optimizes population by perturbing the "top 12 parameters" by 5%
C from the relative index. "Top" in the sense of the most influencers of
C the variable population.
C                               DEFAULT            Value WP2         Description
C        max_tot_fert_norm       & 12.0           & 12.60          & "Normal maximal total fertility"                                 \\
C        p_fioa_cons_const_1     & 0.43           & 0.45           & "Default frac of industrial output allocated to consumption" \\
C        p_ind_cap_out_ratio_1   & 3.0            & 3.15           & "Default industrial capital output ratio"                        \\
C        p_serv_cap_out_ratio_1  & 1.0            & 1.05           & "Default fraction of service sector output ratio"                \\
C        life_expect_norm        & 28.0           & 29.40          & "Normal life expectancy"                                         \\
C        des_compl_fam_size_norm & 3.8            & 4.00           & "Desired normal complete family size"                            \\
C        industrial_capital_init & 210000000000.0 & 199500000000.0 & "Initial industrial investment"                       \\
C        p_land_yield_fact_1     & 1.0            & 0.95           & "Default land yield factor"                           \\
C        p_nr_res_use_fact_1     & 1.0            & 0.95           & "Default non-recoverable resource utilization factor" \\
C        reproductive_lifetime   & 30.0           & 28.5           & "Reproductive life time"                              \\
C        subsist_food_pc         & 230.0          & 218.5          & "Available per capita food"                           \\
C        p_avg_life_ind_cap_1    & 14.0           & 13.29          & "Default average life of industrial capital";         \\
      subroutine test03()
      DOUBLE PRECISION params_values(12)
      dimension jbound(12)
      DOUBLE PRECISION bl(12),bu(12),x0(12),wa(336),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test03
        write(*,*) "Inside test03 at date:"
        call system("date")
      params_values = (/12.0D0, 0.43D0, 3.0D0, 1.0D0, 28.0D0,
     *3.8D0, 210000000000.0D0, 1.0D0, 1.0D0, 30.0D0, 230.0D0,
     *14.0D0/) !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 12
      eps=1.d-10
      ibound=1
      do ijbound=1,12
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,12
C Lower bounds: -5% than default
        bl(iparams) = params_values(iparams)*0.95
C Upper bounds: +5% than default
        bu(iparams) = params_values(iparams)*1.05
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test03, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 12)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test03 at date:"
        call system("date")
      end subroutine test03
C Test03: fu
      subroutine fu_test03(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(12), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test03!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1) = "max_tot_fert_norm"
      params_names(2) = "p_fioa_cons_const_1"
      params_names(3) = "p_ind_cap_out_ratio_1"
      params_names(4) = "p_serv_cap_out_ratio_1"
      params_names(5) = "life_expect_norm"
      params_names(6) = "des_compl_fam_size_norm"
      params_names(7) = "industrial_capital_init"
      params_names(8) = "p_land_yield_fact_1"
      params_names(9) = "p_nr_res_use_fact_1"
      params_names(10) = "reproductive_lifetime"
      params_names(11) = "subsist_food_pc"
      params_names(12) = "p_avg_life_ind_cap_1"
C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine


C--------------- Test04 -----------------
C SIMILAR TO TEST03 BUT 1% INSTEAD OF 5%
C This test optimizes population by perturbing the "top 12 parameters" by 5%
C from the relative index. "Top" in the sense of the most influencers of
C the variable population.
C                               DEFAULT            Value WP2         Description
C        max_tot_fert_norm       & 12.0           & 12.60          & "Normal maximal total fertility"                                 \\
C        p_fioa_cons_const_1     & 0.43           & 0.45           & "Default frac of industrial output allocated to consumption" \\
C        p_ind_cap_out_ratio_1   & 3.0            & 3.15           & "Default industrial capital output ratio"                        \\
C        p_serv_cap_out_ratio_1  & 1.0            & 1.05           & "Default fraction of service sector output ratio"                \\
C        life_expect_norm        & 28.0           & 29.40          & "Normal life expectancy"                                         \\
C        des_compl_fam_size_norm & 3.8            & 4.00           & "Desired normal complete family size"                            \\
C        industrial_capital_init & 210000000000.0 & 199500000000.0 & "Initial industrial investment"                       \\
C        p_land_yield_fact_1     & 1.0            & 0.95           & "Default land yield factor"                           \\
C        p_nr_res_use_fact_1     & 1.0            & 0.95           & "Default non-recoverable resource utilization factor" \\
C        reproductive_lifetime   & 30.0           & 28.5           & "Reproductive life time"                              \\
C        subsist_food_pc         & 230.0          & 218.5          & "Available per capita food"                           \\
C        p_avg_life_ind_cap_1    & 14.0           & 13.29          & "Default average life of industrial capital";         \\
      subroutine test04()
      DOUBLE PRECISION params_values(12)
      dimension jbound(12)
      DOUBLE PRECISION bl(12),bu(12),x0(12),wa(336),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test04
C p_ind_cap_out_ratio_1,3
        write(*,*) "Inside test04 at date:"
        call system("date")
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1
      params_values = (/12.0D0, 0.43D0, 3.0D0, 1.0D0, 28.0D0,
     *3.8D0, 210000000000.0D0, 1.0D0, 1.0D0, 30.0D0, 230.0D0,
     *14.0D0/) !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 12
      eps=1.d-10
      ibound=1
      do ijbound=1,12
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,12
C Lower bounds: -1% than default
        bl(iparams) = params_values(iparams)*0.99
C Upper bounds: +1% than default
        bu(iparams) = params_values(iparams)*1.01
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test04, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 12)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test04 at date:"
        call system("date")
      end subroutine test04
C Test04: fu
      subroutine fu_test04(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(12), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test04!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1) = "max_tot_fert_norm"
      params_names(2) = "p_fioa_cons_const_1"
      params_names(3) = "p_ind_cap_out_ratio_1"
      params_names(4) = "p_serv_cap_out_ratio_1"
      params_names(5) = "life_expect_norm"
      params_names(6) = "des_compl_fam_size_norm"
      params_names(7) = "industrial_capital_init"
      params_names(8) = "p_land_yield_fact_1"
      params_names(9) = "p_nr_res_use_fact_1"
      params_names(10) = "reproductive_lifetime"
      params_names(11) = "subsist_food_pc"
      params_names(12) = "p_avg_life_ind_cap_1"
C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine
C--------------- Test05 -----------------
C Optimize ALL the params by 1%
      subroutine test05()
      DOUBLE PRECISION params_values(96)
      dimension jbound(96)
      DOUBLE PRECISION bl(96),bu(96),x0(96),wa(14736),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test05
        write(*,*) "Inside test05 at date:"
        call system("date")
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1
      params_values = (/ 5000000000.0D0, 1.0D0, 900000000.0D0, 1.5D0,
     * 1000.0D0, 3.8D0, 2.0D0, 1.2D0, 4800000000.0D0, 2.0D0, 0.001D0,
     * 0.02D0, 20.0D0, 3.0D0, 0.1D0, 10.0D0, 790000000000.0D0, 400.0D0,
     * 210000000000.0D0, 600.0D0, 0.75D0, 1.0D0, 2.0D0, 600.0D0, 0.7D0,
     * 28.0D0, 20.0D0, 12.0D0, 1000000000000.0D0, 2.0D0, 2.0D0, 14.0D0,
     * 14.0D0, 20.0D0, 20.0D0, 0.43D0, 0.43D0, 1.0D0, 0.2D0, 0.1D0,
     * 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0,
     * 3.0D0, 1.0D0, 1.0D0, 1.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0,
     * 0.0D0, 0.0D0, 0.0D0, 1.0D0, 1.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0,
     * 1.0D0, 25000000.0D0, 650000000.0D0, 700000000.0D0, 190000000.0D0,
     * 60000000.0D0, 2300000000.0D0, 3200000000.0D0, 136000000.0D0,
     * 1.0D0, 20.0D0, 0.1D0, 30.0D0, 1.0D0, 144000000000.0D0, 20.0D0,
     * 0.07D0, 230.0D0, 4000.0D0, 4000.0D0, 4000.0D0, 4000.0D0,
     * 4000.0D0, 4000.0D0, 4000.0D0, 4000.0D0, 20.0D0, 10.0D0,
     * 8200000.0D0, 1.0D0 /) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 96
      eps=1.d-10
      ibound=1
      do ijbound=1,96
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,96
C Lower bounds: -1% than default
        bl(iparams) = params_values(iparams)*0.99
C Upper bounds: +1% than default
        bu(iparams) = params_values(iparams)*1.01
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test05, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 96)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test05 at date:"
        call system("date")
      end subroutine test05
C Test05: fu
      subroutine fu_test05(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test05!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1)  = "agr_inp_init"
      params_names(2)  = "agr_mtl_toxic_index"
      params_names(3)  = "arable_land_init"
      params_names(4)  = "assim_half_life_1970"
      params_names(5)  = "avg_life_land_norm"
      params_names(6)  = "des_compl_fam_size_norm"
      params_names(7)  = "des_food_ratio_dfr"
      params_names(8)  = "des_ppoll_index_DPOLX"
      params_names(9)  = "des_res_use_rt_DNRUR"
      params_names(10) = "food_short_perc_del"
      params_names(11) = "fr_agr_inp_pers_mtl"
      params_names(12) = "frac_res_pers_mtl"
      params_names(13) = "hlth_serv_impact_del"
      params_names(14) = "income_expect_avg_time"
      params_names(15) = "ind_mtl_emiss_fact"
      params_names(16) = "ind_mtl_toxic_index"
      params_names(17) = "ind_out_in_1970"
      params_names(18) = "ind_out_pc_des"
      params_names(19) = "industrial_capital_init"
      params_names(20) = "inherent_land_fert"
      params_names(21) = "labor_force_partic"
      params_names(22) = "labor_util_fr_del_init"
      params_names(23) = "labor_util_fr_del_time"
      params_names(24) = "land_fertility_init"
      params_names(25) = "land_fr_harvested"
      params_names(26) = "life_expect_norm"
      params_names(27) = "lifet_perc_del"
      params_names(28) = "max_tot_fert_norm"
      params_names(29) = "nr_resources_init"
      params_names(30) = "p_avg_life_agr_inp_1"
      params_names(31) = "p_avg_life_agr_inp_2"
      params_names(32) = "p_avg_life_ind_cap_1"
      params_names(33) = "p_avg_life_ind_cap_2"
      params_names(34) = "p_avg_life_serv_cap_1"
      params_names(35) = "p_avg_life_serv_cap_2"
      params_names(36) = "p_fioa_cons_const_1"
      params_names(37) = "p_fioa_cons_const_2"
      params_names(38) = "p_fr_cap_al_obt_res_2[1]"
      params_names(39) = "p_fr_cap_al_obt_res_2[2]"
      params_names(40) = "p_fr_cap_al_obt_res_2[3]"
      params_names(41) = "p_fr_cap_al_obt_res_2[4]"
      params_names(42) = "p_fr_cap_al_obt_res_2[5]"
      params_names(43) = "p_fr_cap_al_obt_res_2[6]"
      params_names(44) = "p_fr_cap_al_obt_res_2[7]"
      params_names(45) = "p_fr_cap_al_obt_res_2[8]"
      params_names(46) = "p_fr_cap_al_obt_res_2[9]"
      params_names(47) = "p_fr_cap_al_obt_res_2[10]"
      params_names(48) = "p_fr_cap_al_obt_res_2[11]"
      params_names(49) = "p_ind_cap_out_ratio_1"
      params_names(50) = "p_land_yield_fact_1"
      params_names(51) = "p_nr_res_use_fact_1"
      params_names(52) = "p_ppoll_gen_fact_1"
      params_names(53) = "p_ppoll_tech_chg_mlt[1]"
      params_names(54) = "p_ppoll_tech_chg_mlt[2]"
      params_names(55) = "p_ppoll_tech_chg_mlt[3]"
      params_names(56) = "p_ppoll_tech_chg_mlt[4]"
      params_names(57) = "p_res_tech_chg_mlt[1]"
      params_names(58) = "p_res_tech_chg_mlt[2]"
      params_names(59) = "p_res_tech_chg_mlt[3]"
      params_names(60) = "p_res_tech_chg_mlt[4]"
      params_names(61) = "p_serv_cap_out_ratio_1"
      params_names(62) = "p_serv_cap_out_ratio_2"
      params_names(63) = "p_yield_tech_chg_mlt[1]"
      params_names(64) = "p_yield_tech_chg_mlt[2]"
      params_names(65) = "p_yield_tech_chg_mlt[3]"
      params_names(66) = "p_yield_tech_chg_mlt[4]"
      params_names(67) = "perc_food_ratio_init"
      params_names(68) = "pers_pollution_init"
      params_names(69) = "pop1_init"
      params_names(70) = "pop2_init"
      params_names(71) = "pop3_init"
      params_names(72) = "pop4_init"
      params_names(73) = "pot_arable_land_init"
      params_names(74) = "pot_arable_land_tot"
      params_names(75) = "ppoll_in_1970"
      params_names(76) = "ppoll_tech_init"
      params_names(77) = "ppoll_trans_del"
      params_names(78) = "processing_loss"
      params_names(79) = "reproductive_lifetime"
      params_names(80) = "res_tech_init"
      params_names(81) = "service_capital_init"
      params_names(82) = "social_adj_del"
      params_names(83) = "social_discount"
      params_names(84) = "subsist_food_pc"
      params_names(85) = "t_air_poll_time"
      params_names(86) = "t_fcaor_time"
      params_names(87) = "t_fert_cont_eff_time"
      params_names(88) = "t_ind_equil_time"
      params_names(89) = "t_land_life_time"
      params_names(90) = "t_policy_year"
      params_names(91) = "t_pop_equil_time"
      params_names(92) = "t_zero_pop_grow_time"
      params_names(93) = "tech_dev_del_TDD"
      params_names(94) = "urb_ind_land_dev_time"
      params_names(95) = "urban_ind_land_init"
      params_names(96) = "yield_tech_init"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine


C--------------- Test06 -----------------
C Optimize Top18 relative with upper and lower boundaries of 1%
      subroutine test06()
      DOUBLE PRECISION params_values(18)
      dimension jbound(18)
      DOUBLE PRECISION bl(18),bu(18),x0(18),wa(657),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test06
        write(*,*) "Inside test06 at date:"
        call system("date")
      params_values = (/ 0.43D0, 3.0D0, 30.0D0, 28.0D0, 3.8D0, 14.0D0,
     *230.0D0, 1.0D0, 12.0D0, 1.0D0, 1000000000000.0D0, 1.0D0,
     *700000000.0D0, 210000000000.0D0, 3200000000.0D0, 20.0D0,
     *2300000000.0D0, 650000000.0D0 /) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 18
      eps=1.d-10
      ibound=1
      do ijbound=1,18
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,18
C Lower bounds: -3% than default
        bl(iparams) = params_values(iparams)*0.97
C Upper bounds: +3% than default
        bu(iparams) = params_values(iparams)*1.03
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test06, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 18)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test06 at date:"
        call system("date")
      end subroutine test06
C Test06: fu
      subroutine fu_test06(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test06!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) =  "p_fioa_cons_const_1"
      params_names(2) =  "p_ind_cap_out_ratio_1"
      params_names(3) =  "reproductive_lifetime"
      params_names(4) =  "life_expect_norm"
      params_names(5) =  "des_compl_fam_size_norm"
      params_names(6) =  "p_avg_life_ind_cap_1"
      params_names(7) =  "subsist_food_pc"
      params_names(8) =  "p_serv_cap_out_ratio_1"
      params_names(9) =  "max_tot_fert_norm"
      params_names(10) = "p_nr_res_use_fact_1"
      params_names(11) = "nr_resources_init"
      params_names(12) = "p_land_yield_fact_1"
      params_names(13) = "pop2_init"
      params_names(14) = "industrial_capital_init"
      params_names(15) = "pot_arable_land_tot"
      params_names(16) = "p_avg_life_serv_cap_1"
      params_names(17) = "pot_arable_land_init"
      params_names(18) = "pop1_init"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine


C--------------- Test07 -----------------
C Optimize all the params with no influence curvi 5% bounds
      subroutine test07()
      DOUBLE PRECISION params_values(41)
      dimension jbound(41)
      DOUBLE PRECISION bl(41),bu(41),x0(41),wa(2911),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test07
        write(*,*) "Inside test07 at date:"
        call system("date")

      params_values = (/  2.0D0, 1.2D0, 4800000000.0D0,
     *790000000000.0D0,
     *400.0D0, 2.0D0, 14.0D0, 20.0D0, 0.43D0, 1.0D0, 0.2D0, 0.1D0,
     *0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0, 0.05D0,
     *0.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0, 0.0D0, 1.0D0,
     *0.0D0, 0.0D0, 0.0D0, 0.0D0, 4000.0D0, 4000.0D0, 4000.0D0,
     *4000.0D0, 4000.0D0, 4000.0D0, 4000.0D0, 4000.0D0 /) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 41
      eps=1.d-10
      ibound=1
      do ijbound=1,41
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,41
C Lower bounds: -3% than default
        bl(iparams) = params_values(iparams)*0.95
C Upper bounds: +3% than default
        bu(iparams) = params_values(iparams)*1.05
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test07, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 41)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test07 at date:"
        call system("date")
      end subroutine test07
C Test07: fu
      subroutine fu_test07(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test07!!!"

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) =  "des_food_ratio_dfr"
      params_names(2) =  "des_ppoll_index_DPOLX"
      params_names(3) =  "des_res_use_rt_DNRUR"
      params_names(4) =  "ind_out_in_1970"
      params_names(5) =  "ind_out_pc_des"
      params_names(6) =  "p_avg_life_agr_inp_2"
      params_names(7) =  "p_avg_life_ind_cap_2"
      params_names(8) =  "p_avg_life_serv_cap_2"
      params_names(9) =  "p_fioa_cons_const_2"
      params_names(10) = "p_fr_cap_al_obt_res_2[1]"
      params_names(11) = "p_fr_cap_al_obt_res_2[2]"
      params_names(12) = "p_fr_cap_al_obt_res_2[3]"
      params_names(13) = "p_fr_cap_al_obt_res_2[4]"
      params_names(14) = "p_fr_cap_al_obt_res_2[5]"
      params_names(15) = "p_fr_cap_al_obt_res_2[6]"
      params_names(16) = "p_fr_cap_al_obt_res_2[7]"
      params_names(17) = "p_fr_cap_al_obt_res_2[8]"
      params_names(18) = "p_fr_cap_al_obt_res_2[9]"
      params_names(19) = "p_fr_cap_al_obt_res_2[10]"
      params_names(20) = "p_fr_cap_al_obt_res_2[11]"
      params_names(21) = "p_ppoll_tech_chg_mlt[1]"
      params_names(22) = "p_ppoll_tech_chg_mlt[2]"
      params_names(23) = "p_ppoll_tech_chg_mlt[3]"
      params_names(24) = "p_ppoll_tech_chg_mlt[4]"
      params_names(25) = "p_res_tech_chg_mlt[1]"
      params_names(26) = "p_res_tech_chg_mlt[2]"
      params_names(27) = "p_res_tech_chg_mlt[3]"
      params_names(28) = "p_res_tech_chg_mlt[4]"
      params_names(29) = "p_serv_cap_out_ratio_2"
      params_names(30) = "p_yield_tech_chg_mlt[1]"
      params_names(31) = "p_yield_tech_chg_mlt[2]"
      params_names(32) = "p_yield_tech_chg_mlt[3]"
      params_names(33) = "p_yield_tech_chg_mlt[4]"
      params_names(34) = "t_air_poll_time"
      params_names(35) = "t_fcaor_time"
      params_names(36) = "t_fert_cont_eff_time"
      params_names(37) = "t_ind_equil_time"
      params_names(38) = "t_land_life_time"
      params_names(39) = "t_policy_year"
      params_names(40) = "t_pop_equil_time"
      params_names(41) = "t_zero_pop_grow_time"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine


C--------------- Test08 -----------------
C Optimize Top36 relative with upper and lower boundaries of 3%
      subroutine test08()
      DOUBLE PRECISION params_values(36)
      dimension jbound(36)
      DOUBLE PRECISION bl(36),bu(36),x0(36),wa(2286),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test08
        write(*,*) "Inside test08 at date:"
        call system("date")
      params_values = (/ 0.43D0, 3.0D0, 30.0D0, 28.0D0, 3.8D0, 14.0D0,
     *230.0D0, 1.0D0, 12.0D0, 1.0D0, 1000000000000.0D0, 1.0D0,
     *700000000.0D0, 210000000000.0D0, 3200000000.0D0, 20.0D0,
     *2300000000.0D0, 650000000.0D0, 20.0D0, 0.7D0, 600.0D0, 20.0D0,
     *144000000000.0D0, 900000000.0D0, 1.5D0, 600.0D0, 1.0D0, 1000.0D0,
     *0.001D0, 1.0D0, 136000000.0D0, 0.07D0, 3.0D0, 20.0D0, 20.0D0,
     *0.1D0 /) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 36
      eps=1.d-10
      ibound=1
      do ijbound=1,36
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,36
C Lower bounds: -3% than default
        bl(iparams) = params_values(iparams)*0.97
C Upper bounds: +3% than default
        bu(iparams) = params_values(iparams)*1.03
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test08, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 36)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test08 at date:"
        call system("date")
      end subroutine test08
C Test08: fu
      subroutine fu_test08(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test08!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) =  "p_fioa_cons_const_1"
      params_names(2) =  "p_ind_cap_out_ratio_1"
      params_names(3) =  "reproductive_lifetime"
      params_names(4) =  "life_expect_norm"
      params_names(5) =  "des_compl_fam_size_norm"
      params_names(6) =  "p_avg_life_ind_cap_1"
      params_names(7) =  "subsist_food_pc"
      params_names(8) =  "p_serv_cap_out_ratio_1"
      params_names(9) =  "max_tot_fert_norm"
      params_names(10) = "p_nr_res_use_fact_1"
      params_names(11) = "nr_resources_init"
      params_names(12) = "p_land_yield_fact_1"
      params_names(13) = "pop2_init"
      params_names(14) = "industrial_capital_init"
      params_names(15) = "pot_arable_land_tot"
      params_names(16) = "p_avg_life_serv_cap_1"
      params_names(17) = "pot_arable_land_init"
      params_names(18) = "pop1_init"
      params_names(19) = "ppoll_trans_del"
      params_names(20) = "land_fr_harvested"
      params_names(21) = "inherent_land_fert"
      params_names(22) = "lifet_perc_del"
      params_names(23) = "service_capital_init"
      params_names(24) = "arable_land_init"
      params_names(25) = "assim_half_life_1970"
      params_names(26) = "land_fertility_init"
      params_names(27) = "p_ppoll_gen_fact_1"
      params_names(28) = "avg_life_land_norm"
      params_names(29) = "fr_agr_inp_pers_mtl"
      params_names(30) = "agr_mtl_toxic_index"
      params_names(31) = "ppoll_in_1970"
      params_names(32) = "social_discount"
      params_names(33) = "income_expect_avg_time"
      params_names(34) = "social_adj_del"
      params_names(35) = "hlth_serv_impact_del"
      params_names(36) = "processing_loss"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine
C--------------- Test09 -----------------
C Optimize only the "initializers" of the variables that model something from the real life
      subroutine test09()
      DOUBLE PRECISION params_values(17)
      dimension jbound(17)
      DOUBLE PRECISION bl(17),bu(17),x0(17),wa(595),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test09
        write(*,*) "Inside test09 at date:"
        call system("date")
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1
      params_values = (/ 1000000000000.0D0, 700000000.0D0,
     *210000000000.0D0, 3200000000.0D0, 2300000000.0D0, 650000000.0D0,
     *144000000000.0D0, 900000000.0D0, 600.0D0, 136000000.0D0,
     *5000000000.0D0, 8200000.0D0, 190000000.0D0, 60000000.0D0,
     *25000000.0D0, 4800000000.0D0, 790000000000.0D0/) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 17
      eps=1.d-10
      ibound=1
      do ijbound=1,17
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,17
C Lower bounds: -3% than default
        bl(iparams) = params_values(iparams)*0.97
C Upper bounds: +e% than default
        bu(iparams) = params_values(iparams)*1.03
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test09, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 17)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test09 at date:"
        call system("date")
      end subroutine test09
C Test09: fu
      subroutine fu_test09(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test09!!!"

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1)  = "nr_resources_init"
      params_names(2)  = "pop2_init"
      params_names(3)  = "industrial_capital_init"
      params_names(4)  = "pot_arable_land_tot"
      params_names(5)  = "pot_arable_land_init"
      params_names(6)  = "pop1_init"
      params_names(7)  = "service_capital_init"
      params_names(8)  = "arable_land_init"
      params_names(9)  = "land_fertility_init"
      params_names(10) = "ppoll_in_1970"
      params_names(11) = "agr_inp_init"
      params_names(12) = "urban_ind_land_init"
      params_names(13) = "pop3_init"
      params_names(14) = "pop4_init"
      params_names(15) = "pers_pollution_init"
      params_names(16) = "des_res_use_rt_DNRUR"
      params_names(17) = "ind_out_in_1970"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine
C--------------- Test10 -----------------
C Optimize only the "initializers" of the variables that model something from the real life
      subroutine test10()
      DOUBLE PRECISION params_values(17)
      dimension jbound(17)
      DOUBLE PRECISION bl(17),bu(17),x0(17),wa(595),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test10
        write(*,*) "Inside test10 at date:"
        call system("date")
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1
      params_values = (/ 1000000000000.0D0, 700000000.0D0,
     *210000000000.0D0, 3200000000.0D0, 2300000000.0D0, 650000000.0D0,
     *144000000000.0D0, 900000000.0D0, 600.0D0, 136000000.0D0,
     *5000000000.0D0, 8200000.0D0, 190000000.0D0, 60000000.0D0,
     *25000000.0D0, 4800000000.0D0, 790000000000.0D0/) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 17
      eps=1.d-10
      ibound=1
      do ijbound=1,17
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,17
C Lower bounds: -5% than default
        bl(iparams) = params_values(iparams)*0.95
C Upper bounds: +5% than default
        bu(iparams) = params_values(iparams)*1.05
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test10, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 17)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test10 at date:"
        call system("date")
      end subroutine test10
C Test10: fu
      subroutine fu_test10(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test10!!!"

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1)  = "nr_resources_init"
      params_names(2)  = "pop2_init"
      params_names(3)  = "industrial_capital_init"
      params_names(4)  = "pot_arable_land_tot"
      params_names(5)  = "pot_arable_land_init"
      params_names(6)  = "pop1_init"
      params_names(7)  = "service_capital_init"
      params_names(8)  = "arable_land_init"
      params_names(9)  = "land_fertility_init"
      params_names(10) = "ppoll_in_1970"
      params_names(11) = "agr_inp_init"
      params_names(12) = "urban_ind_land_init"
      params_names(13) = "pop3_init"
      params_names(14) = "pop4_init"
      params_names(15) = "pers_pollution_init"
      params_names(16) = "des_res_use_rt_DNRUR"
      params_names(17) = "ind_out_in_1970"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine

C--------------- Test11 -----------------
C Similar to test01 but zxpowl instead of curvi
C wa dimensions for zxpowl: n(n+4)

      subroutine test11()
      DOUBLE PRECISION params_values(1)
      DOUBLE PRECISION x0(1),wa(17),fopt,eps  ! CAREFUL! wa from ZXPOWL has a different dimension than wa from curvi
      integer ier
      external fu_test11
      DOUBLE PRECISION fu_test11
        write(*,*) "Inside test11 at date:"
        call system("date")
      params_values = (/1000000000000.0D0/)      !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 1
      eps=1.d-10
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call ZXPOWL(fu_test11,eps,n,x0,fopt,nfu,wa,ier) ! SUBROUTINE ZXPOWL(F,EPS,N,X,FMIN,ITMAX,WA,IER)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)x0(1)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test11 at date:"
        call system("date")
      end subroutine test11
C Test11: fu
      double precision function fu_test11(x)   ! CAREFUL: the function to use in ZXPOWL differs with the one to use in CURVI
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(1), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      integer nvars
      DOUBLE PRECISION x(1)
      DOUBLE PRECISION res_vars_values(1), params_values(1),f


      nvars = 1
      stopTime = 2100
      params_names = (/"nr_resources_init"/)    !careful! you have to change the list length on top if you add or remove a parameter
      target_vars = (/"population"/)
      params_values = x
      nparams = 1
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      fu_test11 = f
      return
      end function

C--------------- Test16 -----------------
C Optimize Top18 relative with upper and lower boundaries of 1%
      subroutine test16()
      DOUBLE PRECISION params_values(18)
      DOUBLE PRECISION x0(18),wa(396),fopt,eps  ! CAREFUL!  the dimensions of wa for zxpowl and for curvi are not the same!
      external fu_test16
      DOUBLE PRECISION fu_test16
      params_values = (/ 0.43D0, 3.0D0, 30.0D0, 28.0D0, 3.8D0, 14.0D0,
     *230.0D0, 1.0D0, 12.0D0, 1.0D0, 1000000000000.0D0, 1.0D0,
     *700000000.0D0, 210000000000.0D0, 3200000000.0D0, 20.0D0,
     *2300000000.0D0, 650000000.0D0 /) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 18
      eps=1.d-10
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call ZXPOWL(fu_test16,eps,n,x0,fopt,nfu,wa,ier) ! SUBROUTINE ZXPOWL(F,EPS,N,X,FMIN,ITMAX,WA,IER)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 18)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
      end subroutine test16
C Test16: fu
      subroutine fu_test16(x)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(18), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(18)
      DOUBLE PRECISION res_vars_values(1), params_values(18),f
      write(*,*) "*** Inside fu_test16!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      nvars = 1
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) =  "p_fioa_cons_const_1"
      params_names(2) =  "p_ind_cap_out_ratio_1"
      params_names(3) =  "reproductive_lifetime"
      params_names(4) =  "life_expect_norm"
      params_names(5) =  "des_compl_fam_size_norm"
      params_names(6) =  "p_avg_life_ind_cap_1"
      params_names(7) =  "subsist_food_pc"
      params_names(8) =  "p_serv_cap_out_ratio_1"
      params_names(9) =  "max_tot_fert_norm"
      params_names(10) = "p_nr_res_use_fact_1"
      params_names(11) = "nr_resources_init"
      params_names(12) = "p_land_yield_fact_1"
      params_names(13) = "pop2_init"
      params_names(14) = "industrial_capital_init"
      params_names(15) = "pot_arable_land_tot"
      params_names(16) = "p_avg_life_serv_cap_1"
      params_names(17) = "pot_arable_land_init"
      params_names(18) = "pop1_init"

C Variable to optimize:
      target_vars = (/"population"/)
      params_values = x
      nparams = 18
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
      f = -res_vars_values(1)
      write(*,*) "f"
      write(*,*) f
      return
      end

C--------------- Test23 -----------------
C Similar to test 03 but "complex" formula using pop and hwi instead of only pop
      subroutine test23()
      DOUBLE PRECISION params_values(12)
      dimension jbound(12)
      DOUBLE PRECISION bl(12),bu(12),x0(12),wa(336),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test23
        write(*,*) "Inside test23 at date:"
        call system("date")
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1
      params_values = (/12.0D0, 0.43D0, 3.0D0, 1.0D0, 28.0D0,
     *3.8D0, 210000000000.0D0, 1.0D0, 1.0D0, 30.0D0, 230.0D0,
     *14.0D0/) !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 12
      eps=1.d-10
      ibound=1
      do ijbound=1,12
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,12
C Lower bounds: -5% than default
        bl(iparams) = params_values(iparams)*0.95
C Upper bounds: +5% than default
        bu(iparams) = params_values(iparams)*1.05
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test23, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 12)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test23 at date:"
        call system("date")
      end subroutine test23
C Test23: fu
      subroutine fu_test23(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(12), target_vars(2)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(2), params_values(n),f
      write(*,*) "*** Inside fu_test23!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

C Last year of the simulation:
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1) = "max_tot_fert_norm"
      params_names(2) = "p_fioa_cons_const_1"
      params_names(3) = "p_ind_cap_out_ratio_1"
      params_names(4) = "p_serv_cap_out_ratio_1"
      params_names(5) = "life_expect_norm"
      params_names(6) = "des_compl_fam_size_norm"
      params_names(7) = "industrial_capital_init"
      params_names(8) = "p_land_yield_fact_1"
      params_names(9) = "p_nr_res_use_fact_1"
      params_names(10) = "reproductive_lifetime"
      params_names(11) = "subsist_food_pc"
      params_names(12) = "p_avg_life_ind_cap_1"
C Variables to optimize (or at least receive the output from)
      nvars = 2
      target_vars(1) = "population"
      target_vars(2) = "human_welfare_index"
C Rename for clarification
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
C Formula: -(population/1D10 + human_welfare_index)
      f = -(res_vars_values(1)/1D10 + res_vars_values(2))
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine

C--------------- Test24 -----------------
C Similar to test 04 but "complex" formula using pop and hwi instead of only pop
      subroutine test24()
      DOUBLE PRECISION params_values(12)
      dimension jbound(12)
      DOUBLE PRECISION bl(12),bu(12),x0(12),wa(336),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test24
        write(*,*) "Inside test24 at date:"
        call system("date")
      params_values = (/12.0D0, 0.43D0, 3.0D0, 1.0D0, 28.0D0,
     *3.8D0, 210000000000.0D0, 1.0D0, 1.0D0, 30.0D0, 230.0D0,
     *14.0D0/) !careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 12
      eps=1.d-10
      ibound=1
      do ijbound=1,12
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,12
C Lower bounds: -5% than default
        bl(iparams) = params_values(iparams)*0.97
C Upper bounds: +5% than default
        bu(iparams) = params_values(iparams)*1.03
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test24, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 12)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test24 at date:"
        call system("date")
      end subroutine test24
C Test24: fu
      subroutine fu_test24(n,x,f)
C "Wrapper of the wrapper". Here we set the "parameters" of the
C w3Wrapper (stopTime, params_names,target_vars,nparams)
      CHARACTER*1000 params_names(12), target_vars(2)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(2), params_values(n),f
      write(*,*) "*** Inside fu_test24!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

C Last year of the simulation:
      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i":
      params_names(1) = "max_tot_fert_norm"
      params_names(2) = "p_fioa_cons_const_1"
      params_names(3) = "p_ind_cap_out_ratio_1"
      params_names(4) = "p_serv_cap_out_ratio_1"
      params_names(5) = "life_expect_norm"
      params_names(6) = "des_compl_fam_size_norm"
      params_names(7) = "industrial_capital_init"
      params_names(8) = "p_land_yield_fact_1"
      params_names(9) = "p_nr_res_use_fact_1"
      params_names(10) = "reproductive_lifetime"
      params_names(11) = "subsist_food_pc"
      params_names(12) = "p_avg_life_ind_cap_1"
C Variables to optimize (or at least receive the output from)
      nvars = 2
      target_vars(1) = "population"
      target_vars(2) = "human_welfare_index"
C Rename for clarification
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
C Formula: -(population/1D10 + human_welfare_index)
      f = -(res_vars_values(1)/1D10 + res_vars_values(2))
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine

C--------------- Test26 -----------------
C Similar to test 06 but "complex" formula using pop and hwi instead of only pop
      subroutine test26()
      DOUBLE PRECISION params_values(18)
      dimension jbound(18)
      DOUBLE PRECISION bl(18),bu(18),x0(18),wa(657),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      external fu_test26
        write(*,*) "Inside test26 at date:"
        call system("date")
      params_values = (/ 0.43D0, 3.0D0, 30.0D0, 28.0D0, 3.8D0, 14.0D0,
     *230.0D0, 1.0D0, 12.0D0, 1.0D0, 1000000000000.0D0, 1.0D0,
     *700000000.0D0, 210000000000.0D0, 3200000000.0D0, 20.0D0,
     *2300000000.0D0, 650000000.0D0 /) !careful! the following variables depend on the length of this variable: x1,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 18
      eps=1.d-10
      ibound=1
      do ijbound=1,18
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                        1 if the ith variable has only upper bounds.
c                        2 if the ith variable has only lower bounds.
c                        3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,18
C Lower bounds: -3% than default
        bl(iparams) = params_values(iparams)*0.97
C Upper bounds: +3% than default
        bu(iparams) = params_values(iparams)*1.03
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test26, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 18)
C        write(*,20)x0(1),x0(2)
C20    format(/,2d18.8)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test26 at date:"
        call system("date")
      end subroutine test26
C Test26: fu
      subroutine fu_test26(n,x,f)
      CHARACTER*1000 params_names(n), target_vars(2)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(2), params_values(n),f
      write(*,*) "*** Inside fu_test26!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) =  "p_fioa_cons_const_1"
      params_names(2) =  "p_ind_cap_out_ratio_1"
      params_names(3) =  "reproductive_lifetime"
      params_names(4) =  "life_expect_norm"
      params_names(5) =  "des_compl_fam_size_norm"
      params_names(6) =  "p_avg_life_ind_cap_1"
      params_names(7) =  "subsist_food_pc"
      params_names(8) =  "p_serv_cap_out_ratio_1"
      params_names(9) =  "max_tot_fert_norm"
      params_names(10) = "p_nr_res_use_fact_1"
      params_names(11) = "nr_resources_init"
      params_names(12) = "p_land_yield_fact_1"
      params_names(13) = "pop2_init"
      params_names(14) = "industrial_capital_init"
      params_names(15) = "pot_arable_land_tot"
      params_names(16) = "p_avg_life_serv_cap_1"
      params_names(17) = "pot_arable_land_init"
      params_names(18) = "pop1_init"

C Variables to optimize (or at least receive the output from)
      nvars = 2
      target_vars(1) = "population"
      target_vars(2) = "human_welfare_index"
C Rename for clarification
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
C Formula: -(population/1D10 + human_welfare_index)
      f = -(res_vars_values(1)/1D10 + res_vars_values(2))
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine
C--------------- Test31 -----------------
C Optimize the policy triggers:
C ('t_fert_cont_eff_time', 4000.0, 'Year of continued fertility change')
C ('t_ind_equil_time', 4000.0, 'Year of industrial equilibrium')
C ('t_zero_pop_grow_time', 4000.0, 'Time to zero population growth')
C ('t_land_life_time', 4000.0, 'Land life time')
C ('t_policy_year', 4000.0, 'Year of policy change')
C ('t_fcaor_time', 4000.0, 'Year of capital allocation to resource use efficiency')
      subroutine test31()
      DOUBLE PRECISION params_values(6)
      dimension jbound(6)
      DOUBLE PRECISION bl(6),bu(6),x0(6),wa(132),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      integer pv_I
      external fu_test31
        write(*,*) "Inside test31 at date:"
        call system("date")
      DO pv_I=1,6
        params_values(pv_I) = 2050D0   ! all of the policy triggers default value in the Scenario 1 is 4000, corresponding to year 4000. We need to set a value included in the run or these parameters will have no effect. Therefore, we can't set their default value of 4000
      END DO
!careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 6
      eps=1.d-10
      ibound=1
      do ijbound=1,6
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                             1 if the ith variable has only upper bounds.
c                             2 if the ith variable has only lower bounds.
c                             3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,6
C Lower bounds: fixed at the year 2018
        bl(iparams) = 2018D0
C Upper bounds: fixed at the year 2100
        bu(iparams) = 2100D0
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test31, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 6)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test31 at date:"
        call system("date")
      end subroutine test31
C Test31: fu
      subroutine fu_test31(n,x,f)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test31!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) = "t_fert_cont_eff_time"
      params_names(2) = "t_ind_equil_time"
      params_names(3) = "t_zero_pop_grow_time"
      params_names(4) = "t_land_life_time"
      params_names(5) = "t_policy_year"
      params_names(6) = "t_fcaor_time"
C Variables to optimize (or at least receive the output from)
      nvars = 1
      target_vars(1) = "human_welfare_index"
C Rename for clarification
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
C Formula: -(human_welfare_index)
      f = -(res_vars_values(1))
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine

C--------------- Test32 -----------------
C Optimize the policy triggers:
C ('t_fert_cont_eff_time', 4000.0, 'Year of continued fertility change')
C ('t_ind_equil_time', 4000.0, 'Year of industrial equilibrium')
C ('t_zero_pop_grow_time', 4000.0, 'Time to zero population growth')
C ('t_land_life_time', 4000.0, 'Land life time')
C ('t_policy_year', 4000.0, 'Year of policy change')
C ('t_fcaor_time', 4000.0, 'Year of capital allocation to resource use efficiency')
      subroutine test32()
      DOUBLE PRECISION params_values(6)
      dimension jbound(6)
      DOUBLE PRECISION bl(6),bu(6),x0(6),wa(132),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      integer pv_I
      external fu_test32
        write(*,*) "Inside test32 at date:"
        call system("date")
      DO pv_I=1,6
        params_values(pv_I) = 2018D0   ! all of the policy triggers default value in the Scenario 1 is 4000, corresponding to year 4000. We need to set a value included in the run or these parameters will have no effect. Therefore, we can't set their default value of 4000
      END DO
!careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 6
      eps=1.d-10
      ibound=1
      do ijbound=1,6
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                             1 if the ith variable has only upper bounds.
c                             2 if the ith variable has only lower bounds.
c                             3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,6
C Lower bounds: fixed at the year 2018
        bl(iparams) = 2018D0
C Upper bounds: fixed at the year 2100
        bu(iparams) = 2100D0
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test32, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 6)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test32 at date:"
        call system("date")
      end subroutine test32
C Test32: fu
      subroutine fu_test32(n,x,f)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test32!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) = "t_fert_cont_eff_time"
      params_names(2) = "t_ind_equil_time"
      params_names(3) = "t_zero_pop_grow_time"
      params_names(4) = "t_land_life_time"
      params_names(5) = "t_policy_year"
      params_names(6) = "t_fcaor_time"
C Variables to optimize (or at least receive the output from)
      nvars = 1
      target_vars(1) = "human_welfare_index"
C Rename for clarification
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
C Formula: -(human_welfare_index)
      f = -(res_vars_values(1))
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine

C--------------- Test33 -----------------
C Optimize the policy triggers:
C ('t_fert_cont_eff_time', 4000.0, 'Year of continued fertility change')
C ('t_ind_equil_time', 4000.0, 'Year of industrial equilibrium')
C ('t_zero_pop_grow_time', 4000.0, 'Time to zero population growth')
C ('t_land_life_time', 4000.0, 'Land life time')
C ('t_policy_year', 4000.0, 'Year of policy change')
C ('t_fcaor_time', 4000.0, 'Year of capital allocation to resource use efficiency')
      subroutine test33()
      DOUBLE PRECISION params_values(6)
      dimension jbound(6)
      DOUBLE PRECISION bl(6),bu(6),x0(6),wa(133),fopt,eps  ! don't really know the difference between declaring them as dimension or as double precision
      integer pv_I
      external fu_test33
        write(*,*) "Inside test33 at date:"
        call system("date")
      DO pv_I=1,6
        params_values(pv_I) = 2034D0   ! all of the policy triggers default value in the Scenario 1 is 4000, corresponding to year 4000. We need to set a value included in the run or these parameters will have no effect. Therefore, we can't set their default value of 4000
      END DO
!careful! the following variables depend on the length of this variable: x0,nparams,params_names,n,jbound,bl,bu,wa
      x0 = params_values
      n = 6
      eps=1.d-10
      ibound=1
      do ijbound=1,6
        jbound(ijbound) = 3 ! 0 if the ith variable has no constraints.
c                             1 if the ith variable has only upper bounds.
c                             2 if the ith variable has only lower bounds.
c                             3 if the ith variable has both upper and lower bounds
      end do
      do iparams=1,6
C Lower bounds: fixed at the year 2018
        bl(iparams) = 2018D0
C Upper bounds: fixed at the year 2100
        bu(iparams) = 2100D0
      end do
C BORRAR:
      write(*,*) "params_values"
      write(*,*) params_values

      write(*,*) "bl"
      write(*,*) bl
      write(*,*) "bu"
      write(*,*) bu
C BORRAR^
      nfu=0         ! <--- MAX NUMBER OF CALLS TO FU
      idiff=2
      kmax=3
C IMPORTANT FACT ON wa !!! Read its comment on top

      call curvif(fu_test33, n, x0, fopt, eps, ibound,
     * jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
      write(*,5)ier,nfu,nit
5     format(/,' ier = ',i3,' nfu = ',i5,' nit = ',i6,/)
        write(*,10)
10    format(/,' Vector solucion = ',/)
        write(*,*)(x0(ii), ii = 1, 6)
        write(*,30)fopt
30    format(/,' fopt = ',d18.8,//)
        write(*,*) "Finished test33 at date:"
        call system("date")
      end subroutine test33
C Test33: fu
      subroutine fu_test33(n,x,f)
      CHARACTER*1000 params_names(n), target_vars(1)
      INTEGER stopTime
      INTEGER nparams !careful! this has to correspond to the length of both arrays
      INTEGER nvars
      DOUBLE PRECISION x(n)
      DOUBLE PRECISION res_vars_values(1), params_values(n),f
      write(*,*) "*** Inside fu_test33!!!"
C p_ind_cap_out_ratio_1,3
C p_avg_life_ind_cap_1,14
C p_avg_life_serv_cap_1,20
C p_serv_cap_out_ratio_1,1

      stopTime = 2100
C Parameters names to perturb (the values are set in "test0i"):
C (from most to least influence in Relative 5%)
      params_names(1) = "t_fert_cont_eff_time"
      params_names(2) = "t_ind_equil_time"
      params_names(3) = "t_zero_pop_grow_time"
      params_names(4) = "t_land_life_time"
      params_names(5) = "t_policy_year"
      params_names(6) = "t_fcaor_time"
C Variables to optimize (or at least receive the output from)
      nvars = 1
      target_vars(1) = "human_welfare_index"
C Rename for clarification
      params_values = x
      nparams = n
      call w3Wrapper(stopTime,
     * params_names,params_values,target_vars,nparams,
     * nvars,res_vars_values)
C Formula: -(human_welfare_index)
      f = -(res_vars_values(1))
      write(*,*) "f"
      write(*,*) f
      return
      end subroutine

module testData
  integer nparams,stopTime,ntarget_vars
  DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE ::  params_values, bl, bu,  wa
  INTEGER, DIMENSION(:), ALLOCATABLE ::  jbound
  CHARACTER(LEN=1000), DIMENSION(:), ALLOCATABLE ::  params_names,target_vars
  DOUBLE PRECISION fopt
  SAVE
  contains
end module testData

      SUBROUTINE ZXPOWL(F,EPS,N,X,FMIN,ITMAX,WA,IER)
C     ZXPOWL
C.ZXPOWL.................S/D............................................
C
C     FUNCTION          - POWELL'S ALGORITHM TO FIND A (LOCAL) MINIMUM
C                         OF A REAL FUNCTION OF N REAL VARIABLES
C     USAGE             - CALL ZXPOWL (F,EPS,N,X,FMIN,ITMAX,WA,IER)
C     PARAMETER   F     - A FUNCTION SUBPROGRAM WRITTEN BY THE USER
C                 EPS   - CONVERGENCE CRITERION - SEE ELEMENT
C                            DO
C                 N     - LENGTH OF THE VECTOR ARRAY X (INPUT)
C                 X     - A VECTOR ARRAY OF LENGTH N. ON INPUT, X IS AN
C                           INITIAL GUESS FOR THE MINIMUM, ON OUTPUT
C                          X IS THE COMPUTED MINIMUM POINT
C                 FMIN- - F(X)-FUNCTION F EVALUATED AT X OPTIMUM
C                 ITMAX - ON INPUT = THE MAXIMUM ALLOWABLE NUMBER OF
C                         ITERATIONS PER ROOT AND ON OUTPUT = THE
C                         NUMBER OF ITERATIONS USED
C                 IER   - ERROR PARAMETER (OUTPUT)
C                 WA    - AUXILIARY VECTOR. MUST BE DECLARED IN THE MAIN
C                            PROGRAM WITH DIMENSION N(N+4)
C                         TERMINAL ERROR = 128+N
C                         N = 1 NO FINITE MINIMUM OBTAINED
C                         N = 2 F IS LEVEL ALONG A LINE THROUGH X
C                         N = 4 FAILURE TO CONVERGE IN ITMAX
C                               ITERATIONS
C                         N = 8 GRADIENT 'LARGE' AT CALCULATED MINIMUM
C  NUEVO DESDE ACA:
C                          IERROR=140 (no se que N es) es porque hubo division por 0
C  NUEVO HASTA ACA:
C    AUTHOR/IMPLEMENTER - O. G. JOHNSON/L. L. WILLIAMS
C    PRECISION                  DOUBLE
      DOUBLE PRECISION X(1),WA(1),F,FMIN,FS,FB,FL,DB,HX,DM,
     *DQ,HQ,HD,DC,FM,FC,DA,FA,EPS
C     LANGUAGE               - FORTRAN
C...................................................
C     LATEST REVISION - MARCH 22, 1971
C
C	30/05/2003: Statement in line 90 has been modified from the original version
C
C
      IER = 0
      ISW3 = 0
      N2 = N*N
      ID = N2
      IP = ID+N
      IS = IP+N
      IT = IS+N
      DO 5 K=1,N
      IPK = IP +K
      WA(IPK) = X(K)
      ITK = IT + K
5     WA(ITK) = 1.
C                             COMPUTE FIRST FUNCTION VALUE
      FS = F(WA(IP+1))
	    ! write(6,1000)FS,EPS,n
	    write(1,1000)FS,EPS,n
1000  format(/,' === First function value en ZXPOWL = ',d16.8,
     *' EPS = ',d16.8,' n = ',i3)
C                                        pause
      FB = FS
      I = 1
      IC = 1
      ITT = 0
      M = 0
      MF = 0
      ISW1 = 1
10    ITT = ITT+1
      FL = FS
      DO 15 K=1,N
      IDK = ID + K
15    WA (IDK) = 0.
      IDD = I
      I = IC
      ISW2 = 0
20    NS = 0
      IPP = 0
      DB = 0.
      IPI = IP + I
      IF (ISW2 .EQ. 0) HX = WA(IPI)
      IF ((ITT .NE. 1) .OR. (ISW1 .NE. 1)) GO TO 25
      DM = .1
C1    IF (DABS(HX) .GT. 1.) DM = -DM*HX
      IF (DABS(HX) .GT. 1.D0) DM = -DM*HX
      GO TO 75
25    IF (ISW1 .NE. 2) GO TO 30
      DM = DQ
      IF (ITT .EQ. 1) DM = HQ
      GO TO 75
30    ITI = IT + I
      HD = WA(ITI)

C2	Original statement:
C2    IF (ISW2 .EQ. 1) HD = WA(IS+1)

C2	Modified statement:
      IF (ISW2 .EQ. 1) HD = WA(IS+I)
      DC = HQ
      IF (ITT .EQ. 2)DC=0.01
      DM = DC
      ASSIGN 35 TO IMRK
      GO TO 120
35    DM=0.5*DC-(FM-FB)/(DC*HD)
      IF(FM .GE. FB)GO TO 40
      FC = FB
      FB = FM
      DB = DC
      IF (DM .EQ. DB) GO TO 160
      DC = 0.
      GO TO 50
40    IF (DM .NE. DB) GO TO 45
      DA = DC
      FA = FM
      GO TO 70
45    FC = FM
50    ASSIGN 55 TO IMRK
      GO TO 120
C                               ANALYZE NEW FUNCTION VALUE
55    IF (FM .LT. FB) GO TO 60
      DA = DM
      FA = FM
      GO TO 65
60    DA = DB
      FA = FB
      DB = DM
      FB = FM
65    IF((DC-DA)/(DB-DA) .GT. 0.0) GO TO 115
      IF (DB .NE. 0.0) GO TO 160
70    NS = 1
      DM = -DC
75    IF (NS .LE. 15) GO TO 85
      IF (FS .NE. FM) GO TO 80
      DB = 0.
      MF = N+2
      GO TO 160
C1    80 IF (DABS(DM) .LE. 10.E5) GO TO 85
80    IF (DABS(DM) .LE. 10.D5) GO TO 85
      ISW3 = 1
      GO TO 160
85    NS = NS + 1
      ASSIGN 90 TO IMRK
      GO TO 120
90    IF (FM .LT. FB) GO TO 100
      IF (FM .EQ. FB) GO TO 105
      IF (NS .EQ. 1) GO TO 110
95    DC = DM
      FC = FM
      GO TO 115
100   DA = DB
      FA = FB
      DB = DM
      FB = FM
      DM = DM+DM
      GO TO 75
105   IF (FS .EQ. FB) GO TO 100
      IF (NS .NE. 1) GO TO 95
110   DA = DM
      FA = FM
      DM = -DM
      GO TO 75
115   HD=(FC-FB)/(DC-DB)+(FA-FB)/(DB-DA)
      DM=0.5*(DA+DC)+(FA-FC)/(HD+HD)
      IPP=IPP+1
      ASSIGN 140 TO IMRK
120   IF (ISW2 .EQ. 1) GO TO 125
      IPI = IP+I
      WA(IPI) = HX+DM
      GO TO 135
125   DO 130 K=1,N
      IPK = IP+K
      MK = M+K
      WA(IPK) = X(K)+DM*WA(MK)
130   CONTINUE
135   FM = F(WA(IP+1))
      GO TO IMRK,(35, 55, 90, 140)
140   IF (FM .LE. FB) GO TO 150
      IF (IPP .EQ. 3) GO TO 155
C DESDE ACA NUEVO:
C   Si lo de la division de abajo da 0 entonces salgamos de zxpowl, no nos importa nada
      IF ((DM-DB) .EQ. 0.0) GO TO 235
C HASTA ACA NUEVO^
      IF ((DC-DB)/(DM-DB) .GT. 0.0) GO TO 145
      DA = DM
      FA = FM
      GO TO 115
145   DC = DM
      FC = FM
      GO TO 115
150   DB = DM
      FB = FM
155   HD=(HD+HD)/(DC-DA)
      ITI =  IT+I
      IF (ISW2 .NE. 1) WA(ITI) = HD
      ISI = IS+I
      WA(ISI) = HD
      IF (FB .EQ. FS) DB = 0.
160   IF (ISW2 .EQ. 1) GO TO 165
      IDI = ID+I
      WA(IDI) = WA(IDI)+DB
      HD = HX+DB
      IPI = IP+I
      WA(IPI) = HD
      X(I) = HD
      GO TO 175
165   DO 170 K=1,N
      MK = M+K
      HD = DB*WA(MK)
      IDK = ID+K
      WA(IDK) = WA(IDK)+HD
      HD = X(K)+HD
      IPK = IP+K
      WA(IPK)=HD
170   X(K) = HD
175   IF (ISW3 .NE. 1) GO TO 176
      IER = 129
      GO TO 230
176   FS = FB
      IF (I .EQ. N) I=0
      I = I+1
      IF (ISW1 .NE. 0.0) GO TO 185
      IF (DB .NE. 0.0) GO TO 180
      IF (I .NE. IC) GO TO 20
180   IC = I
      ISW1 = 1
      IF (ITT .GT. N) ISW2 = 1
      I = IDD
      GO TO 20
185   M = M+N
      IF (M .EQ. N2) M=0
      IF (ISW1 .NE. 1) GO TO 205
      IF (I .EQ. 1) ISW2 = 1
      IF (I .NE. IDD) GO TO 20
      HQ = 0.
      DO 190 K=1,N
      IDK = ID+K
      HQ = HQ+WA(IDK)**2
190   CONTINUE
      IF (HQ .NE. 0.0) GO TO 195
      IF (MF .GT. (N+1)) IER = 130
      GO TO 230
195   DQ = DSQRT(HQ)
      HQ = DMIN1(1.D0,DQ)
      DO 200 K=1,N
      MK = M+K
      IDK = ID+K
      WA(MK) = WA(IDK)/DQ
200   CONTINUE
      ISW1 = 2
      GO TO 20
205   ISW1 = 0
      IF ((FL-FS) .LE. (EPS*DMAX1(1.D0,DABS(FS)))) GO TO 215
206   IF (ITT .GT. ITMAX) GO TO 210
      MF = 0
      GO TO 10
210   IER = 132
      GO TO 230
215   IF (MF .LE. (N+1)) GO TO 220
      IER = 130
      GO TO 230
220   MF = MF+1
      DQ = 0.
      DO 225 K=1,N
      IDK = ID+K
      IPK = IP+K
      DQ = DQ+DABS(WA(ID+K))/DMAX1(1.D0,DABS(WA(IP+K)))
225   CONTINUE
      IF (DQ .LE. N*EPS) GO TO 230
      IF (MF .LE. N) GO TO 10
      IER = 136
C Desde aca nuevo:
      GO TO 230
235   IER = 140
      write(*,*) "----------------"
      write(*,*) "ENTRO A DONDE NO TENÍA QUE ENTRAR."
      write(*,*) "   VOY A IGNORAR EL ERROR DE ZXPOWL"
      write(*,*) "----------------"
      write(*,*) ""
C Hasta aca nuevo^
230   FMIN = FB
      ITMAX = ITT
      IF (IER .NE. 0) GO TO 9000
9000  CONTINUE

      ! write(6,9010)FMIN
	     write(1,9010)FMIN
9010   format(/,' ======== FMIN = ',d16.8)
C       pause 7
      RETURN
      END SUBROUTINE ZXPOWL

c ********************************************************************
c     This is the file curvif.for using only function values
c  Ale: Según Hugo: El paquete completo incluye los archivos CURVIf (éste), CURVIg, y CURVIh según se tengan solamente valores de la función, o además gradientes y hessianos respectivamente
c ---------------------------------------------------------------------
      subroutine curvif(fu, n, x0, fopt, eps, ibound,
     *                  jbound, bl, bu, wa, nfu, nit, idiff, kmax, ier)
C     !ms$attributes DLLEXPORT :: curvif
c
c  --------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c        fu:  user supplied subroutine which computes the function
c             to be minimized.
c
c     Usage:  call fu(n,x,f)
c         n:  dimension of x.
c         x:  n-dimensional vector.
c         f:  value of the function at the point x.    ! Ale: fx en nugrad
c
c         n:  dimension of the problem.
c
c        x0:  initial guess point.
c
c       eps:  tolerance for the stopping criterion.
c
c    ibound:  parameter such that if equal to
c             0 is an unconstrained problem
c             1 is a constrained problem.
c
c    jbound:  working vector of dimension n defining the sort of
c             constraint for each variable (only used when ibound.ne.0).
c             jbound(i) = 0 if the ith variable has no constraints.
c                         1 if the ith variable has only upper bounds.
c                         2 if the ith variable has only lower bounds.
c                         3 if the ith variable has both upper and
c                           lower bounds.
c
c        bl:  vector of lower bounds (not used if ibound=0).
c
c        bu:  vector of upper bounds (not used if ibound=0).
c
c        wa:  working vector of dimension (see output)
c             9*n+n*(n+1)/2+n*n+max(7*n-n*(n+1)/2,0)
c
c       nfu:  maximum number of function evaluations. If equal to
c             zero, the default value of 5000*n is used.
c
c     idiff:  Choose forward or central differences.  Forward
c            differences require fewer function evaluations and
c             should be favored unless the problem is exceedingly
c             difficult.
c             idiff = 1  forward differences
c             idiff = 2  central differences
c
c     kmax:   The parameter kmax is such that the hessian is
c             recomputed every kmax iterations.
c             We recommend kmax = 3 unless the problem is
c             very difficult.  In this case choose kmax = 1 or 2.
c----------------------------------------------------------------------
c    Output:
c
c        x0:  best obtained point.
c
c      fopt:  value of the function at the point x0.
c
c       nfu:  number of function evaluations.
c
c       nit:  number of iterations.
c
c        wa:  this vector contains gradient(x0) in the unconstrained
c             case, and the projected gradient(x0) for constrained
c             problems.
c
c       ier:  0 convergence has been achieved.
c             1 maximum number of function evaluations exceeded.
c             2 failure to converge.
c             3 wrong input in a constrained problem. In such a case
c               the components of vectors bl and bu set to 1.d30
c               were ill defined on input.
c----------------------------------------------------------------------
c      The algorithm for unconstrained optimization is described in:
c       "A curvilinear search using tridiagonal secant updates for
c                    unconstrained optimization"
c      J.E.Dennis,N.Echebest,M.T.Guardarucci,J.M.Martinez,H.D.Scolnik
c      and C.Vacchino.
c      SIAM J. on Optimization, Vol.1, Number 3, August 1991, page 351
c----------------------------------------------------------------------
c   WARRANTY  - BYTECH ARGENTINA warrants only that our own testing
c               procedures has been applied to this code.
c
c        No other warranty, expressed or implied is applicable.
c----------------------------------------------------------------------
c   Technical support: send mail to -->   hugo@nobi.uba.ar
c----------------------------------------------------------------------
c               Latest revision: January 2, 1996
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension x0(n),wa(1),bl(n),bu(n),jbound(n)
      common /busca/eig,dnor,v1
      common/npar/maxfun
      common/ierp/ierp
      external fu
c----------------------------------------------------------------------
c
c     The parameter kmax is such that the hessian is recomputed every
c     kmax iterations. For every other iteration only the tridiagonal
c     matrix T is updated in the decomposition H = Q(t)*T*Q using
c     the least change secant update theory (see reference).
c     Hence, larger values of kmax lead to fewer hessian evaluations.
c     The chosen value of 3 has been found experimentally to be a good
c     compromise between highly and mildly nonlinear problems.
c
c----------------------------------------------------------------------
c                data kmax/3/
      data sal/1.d-5/
      ier=0
      ierp=0
      n1=n*(n+1)/2
c----------------------------------------------------------------------
c     Set up pointers of the working vector.
c----------------------------------------------------------------------
c     Pointers for the working vector wa( ) are as follows:
c     nx1  :  the new point x1.
c     ngr0 :  the gradient at the point x0.
c     ngry :  ngr0+n
c     nxy  :  ngry+n
c     ngr1 :  the gradient at the new point.
c     nqt  :  Q transposed, where Q is an orthogonal matrix.
c     nhe  :  the Hessian
c     nd   :  diagonal  of the  tridiagonal matrix
c     ne   :  subdiagonal of the tridiagonal matrix
c     nw   :  - Q*grad0
c     nsq  :  Q*s
c----------------------------------------------------------------------
      nqt=1
      nx1=nqt+n*n
      ngr0=nx1+n
      ngry=ngr0+n
      nxy=ngry+n
      ngr1=nxy+n
      nw=ngr1+n
      nsq=nw+n
      nd=nsq+n
      ne=nd+n
      nhe=ne+n
      naux1=nhe
      naux2=nx1
c----------------------------------------------------------------------
c     Auxiliar indexes.
c----------------------------------------------------------------------
      nmx1=nx1-1
      nmgr0=ngr0-1
      nmgr1=ngr1-1
      nmgry=ngry-1
      nmxy=nxy-1
      nmw=nw-1
      nmqt=nqt-1
      nmd=nd-1
      nme=ne-1
      ndc=naux1-1
      nec=naux2-1
c---------------------------------------------------------------------
c     Set default value for maxfun
c----------------------------------------------------------------------
      maxfun=5000*n
      if(nfu.gt.0)maxfun=nfu
      nit=0
      nfu=0
c----------------------------------------------------------------------
c     Compute initial values of function and gradient.
c----------------------------------------------------------------------
      if(ibound.eq.0)then
              call fu(n,x0,fopt)
              nfu=nfu+1
              call nugrad(n,x0,fu,fopt,wa(ngr0),1,idiff,nfu)
      else
c ---------------------------------------------------------------------
c     If it is a constrained problem is transformed into an
c     unconstrained one according to ibound.
c     The initial point is stored in wa(nxy).
c----------------------------------------------------------------------
              do i=1,n
                      wa(nmxy+i)=x0(i)
              end do
c----------------------------------------------------------------------
c     x0, although transformed, is kept as the starting point of the
c     new unconstrained problem.
c----------------------------------------------------------------------
              call transf(n,nfu,wa(nxy),bl,bu,1,x0,jbound,ier)
              if(ier.eq.3)return
              call fu(n,wa(nxy),fopt)
              nfu=nfu+1
              call nugrad(n,wa(nxy),fu,fopt,wa(ngry),1,idiff,nfu)
              call gradx(n,x0,bl,bu,wa(ngry),wa(ngr0),jbound)
      end if
c----------------------------------------------------------------------
c     Optimality test.
c----------------------------------------------------------------------
      ier=ierstf(n,bl,bu,x0,fopt,wa(ngr0),wa(ngry),wa(nxy),eps,nfu,
     *          wa(naux1),fu,idiff,ibound,jbound)
      if (ier.gt.-1) go to 40
      kal=0
10    k=1
c----------------------------------------------------------------------
c     Compute and factorize the Hessian
c     as h=Qt*T*Q , where Q is an
c     orthogonal matrix and T is a
c     tridiagonal matrix.
c----------------------------------------------------------------------
      f=fopt
      if(ibound.eq.0)then
              call numhes(n,x0,f,wa(nhe),fu,wa(nx1),wa(ngr1),wa(nw),nfu)
      else
c----------------------------------------------------------------------
c     The Hessian of the constrained problem is stored in wa(nxy)
c     and the Hessian of the unconstrained one in x0
c----------------------------------------------------------------------
              call numhes(n,wa(nxy),f,wa(nhe),fu,wa(nx1),wa(ngr1),
     *                    wa(nw),nfu)
              call hessix(n,x0,bl,bu,wa(ngry),wa(nhe),jbound)
      end if
c----------------------------------------------------------------------
      call factor(n,n1,wa(nhe),wa(nqt),wa(nd),wa(ne),0)
20    nit=nit+1
c----------------------------------------------------------------------
c     Compute the smallest eigenvalue of
c     the tridiagonal matrix.
c     Set parameters for "lsfmin"  (line search without derivatives)
c----------------------------------------------------------------------
      do i=1,n
              wa(ndc+i)=wa(nmd+i)
              wa(nec+i)=wa(nme+i)**2
      end do

      call autova(wa(naux1),wa(naux2),n)
      eig=wa(naux1)
      dnor=dnrm2(n,wa(ngr0),1)
      v1=1.d0
      v3=sal

      if (eig.ge.sal) then
              cotmu=v1/eig
              step= cotmu
      else
              if(eig.gt.0.d0)then
                      v1=5.d0*eig
                      cotmu= v1/(eig)
                      step= v1/(eig+(sal-eig)+1.d-2*dsqrt(dnor))
              else
                      v2=1.d0
                      v1=1.d0
                      if(dnor.gt.1.d2) v2=1.d-1
                      cotmu=v1/sal
                      v3=dmax1(sal, 1.d-1*dabs(eig))
                      step=v1/(v3+v2*dsqrt(dnor))
              end if
      end if

      iqt=nmqt

      do j=1,n
              aw=0.d0
              do i=1,n
                      iqt=iqt+1
                      aw=aw-wa(iqt)*wa(nmgr0+i)
              end do
              wa(nmw+j)=aw
      end do
c-----------------------------------------------------------------------
c     Define parameters for lsfmin.
c-----------------------------------------------------------------------
      f=fopt
      step0=step
      xmu=0.d0
      dgg=dnor*dnor
      der=-dgg/v1
      maxfn=50
c---------------------------------------------------------------------
      call lsfmin(fu,n,x0,bl,bu,wa(nqt),wa(nd),wa(ne),wa(nw),xmu,
     * f,wa(nx1),wa(nsq),wa(nxy),wa(naux1),step0,cotmu,
     * maxfn,ierz,ibound,jbound,nf1)
c----------------------------------------------------------------------
c     Analize the amount of descent of the function and the step
c     s(xmu) from the curvilinear search.
c     Analize alternatives for improving the descent.
c     Analyze alternatives if lsfmin did not converge.
c----------------------------------------------------------------------
      nfu=nfu+nf1
      sder=0.d0
      sver=0.d0
      dx0=dnrm2(n,x0,1)

      do i=1,n
              sder=sder+wa(nmgr0+i)*(wa(nmx1+i)-x0(i))
              sver=dmax1(dabs(wa(nmx1+i)-x0(i)),sver)
      end do

      if(sver.le.1.d-13*dmax1(1.d0,dx0).or.ierz.gt.0)then
              k=kmax
              ierp=2
      end if

      if((f-fopt).le.0.9d0*der*xmu.or.(f-fopt).le.7.d-1*sder)then
              if(k.gt.3)then
                      k=kmax
              end if
      end if
c--------------------------------------------------------------------
c     Calculate the gradient at the new iterate x1
c--------------------------------------------------------------------
      f1=f
      if(ibound.eq.0)then
              call nugrad(n,wa(nx1),fu,f,wa(ngr1),1,idiff,nfu)
      else
              call nugrad(n,wa(nxy),fu,f,wa(ngry),1,idiff,nfu)
              call gradx(n,wa(nx1),bl,bu,wa(ngry),wa(ngr1),jbound)
      end if
c--------------------------------------------------------------------
c     Optimality test.
c---------------------------------------------------------------------
      irot=3
c---------------------------------------------------------------------
c     Decide if converged or if it necessary to continue
c--------------------------------------------------------------------
      kal=kal+1
      if(dabs(f1-fopt).ge.1.d-13*dmax1(1.d0,dabs(fopt)))then
              kal=0
              ierp=0
      else
              if(kal.ge.2)ierp=2
      end if

      ier=ierstf(n,bl,bu,wa(nx1),f1,wa(ngr1),wa(ngry),wa(nxy),eps,
     *           nfu,wa(naux1),fu,idiff,ibound,jbound)
      if(ier.eq.-2)k=kmax
      if(ier.le.-1)then
              if(ierp.eq.2.and.kal.gt.5)then
                      ier=2
                      go to 30
              end if
              irot=1
c----------------------------------------------------------------------
c     Decide if either update the Hessian or
c     recompute it.
c----------------------------------------------------------------------
              if(k.lt.kmax)then
                      k=k+1
                      call updaf(n,bl,bu,wa(nd),wa(ne),wa(nqt),wa(nsq),
     *                     x0,fu,ig,wa(ngr0),wa(ngr1),wa(naux1),ibound,
     *                     jbound,nfu,idiff)
                      irot=2
              end if
      end if
c----------------------------------------------------------------------
c     Restore the current iterate, its function value and
c     its numerical gradient.
c     If irot.le.2 continue
c     else --> return
c----------------------------------------------------------------------
30    fopt=f1

      do i=1,n
              x0(i)=wa(nmx1+i)
              wa(nmgr0+i)=wa(nmgr1+i)
      end do

      go to (10,20)irot
c----------------------------------------------------------------------
c     Restore the optimal point and the projected gradient
c     in the original variables before return.
c----------------------------------------------------------------------
40    if(ibound.ne.0)then
              do i= 1,n
                      x0(i)= wa(nmxy+i)
                      wa(nmgr0+i)=wa(naux1+i-1)
              end do
      end if
      return
      end

c----------------------------------------------------------------------
c     Routine transf implements the change of variables for
c     transforming unconstrained problems into contrained ones
c     and viceversa.
c----------------------------------------------------------------------
      subroutine transf(n,nu,z,bl,bu,mar,x,jbound,ier)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c         n:  number of variables.
c        nu:  flag for starting calculations such that if
c             0 analizes the user-supplied data.
c             1 skips the analysis.
c        bl:  vector of lower bounds.
c        bu:  vector of upper bounds.
c       mar:  flag such that if
c             1 transforms the constrained problem into the
c               unconstrained one.
c             2 transforms the unconstrained problem into the
c               constrained one.
c         z:  if mar=1 it contains the current iterate of the constrained
c             problem.
c         x:  if mar=2 it contains the current iterate of the unconstrained
c             problem.
c
c    jbound:  working vector of dimension n defining the sort of
c             constraint for each variable
c             (only used when ibound.ne.0)
c             jbound(i) = 0 if the ith variable has no contraints.
c                         1 if the ith variable has only upper bounds.
c                         2 if the ith variable has only lower bounds.
c                         3 if the ith variable has both upper and
c                           lower bounds.
c    Output:
c
c         x:  if mar = 1 , x is the transform of the input z.
c   or
c         z:  if mar = 2,  z is the transform of the input x.
c
c       ier:  3 if there exists an input error in the constraints;
c             otherwise is not altered.

c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension x(n),bl(n),bu(n),z(n),jbound(n)
      data tol/0.10842022d-18/
      if(mar.eq.1)then
c----------------------------------------------------------------------
c     Analize if the user-supplied data is coherent.
c
c     If the given point does not satisfy the constraints it is
c     projected onto the corresponding region.
c----------------------------------------------------------------------
          if(nu.eq.0)then
                    na1=0
                    na2=0
                    do i=1,n
	        if(jbound(i).eq.3)then
                                  if(bu(i).lt.bl(i))then
                                   na2=na2+1
                                  end if
                       end if
                    end do
                    if(na2.ne.0)then
                        ier=3
                        return
                    end if
                    do i=1,n
                        if(jbound(i).ne.0)then
                          if(jbound(i).ne.2)then
                            if(z(i).gt.bu(i))then
                                z(i)=bu(i)
                            end if
                        end if
                        if(jbound(i).gt.1)then
                            if(z(i).lt.bl(i))then
                                z(i)=bl(i)
                            end if
                        end if
                       end if
                    end do
        end if
c----------------------------------------------------------------------
c   Compute the coordinates of the unconstrained transformed problem.
c   if jbound(i)=1,   using   x = dsqrt(bu - z)
c   if jbound(i)=2,   using   x = dsqrt(z - bl)
c   if jbound(i)=3,   using   x = dasin(dsqrt( (z - bl) / (bu - bl )))
c----------------------------------------------------------------------
        do i=1,n
       x(i)=z(i)
            if(jbound(i).eq.3)then
c-------------------------------------------------------------------
                    wa2=bu(i)-bl(i)
                    if( dabs(wa2).gt.tol* dabs((bu(i)+bl(i))/2))then
                             x(i)=dasin(dsqrt((z(i)-bl(i))/wa2))
                    else
                             x(i)=0.d0
                    end if
            else
                    if(jbound(i).eq.1)then
                        x(i)=dsqrt(bu(i)-z(i))
                    else
                        if(jbound(i).eq.2)then
                            x(i)=dsqrt(z(i)-bl(i))
                        end if
                    end if
           end if
        end do
        return
c----------------------------------------------------------------------
c      if mar.ne.1 transform the point x of the unconstrained problem
c      into the corresponding point z of the constrained problem.
c      if jbound(i)=1,   using      z = bu - x**2
c      if jbound(i)=2,   using      z = bl + x**2
c      if jbound(i)=3,   using      z = bl + (bu - bl)* (sin x)**2
c----------------------------------------------------------------------
      else
            do i=1,n
                    if(jbound(i).eq.1)then
                        z(i)=-x(i)**2+bu(i)
                    else
                       if(jbound(i).eq.2)then
                           z(i)=x(i)**2+bl(i)
                       else
                          if(jbound(i).eq.3)then
                              wa2=bu(i)-bl(i)
                              z(i)=bl(i)+wa2*(dsin(x(i)))**2
                          else
                              z(i)=x(i)
                          end if
                       end if
                     end if
             end do
      end if
      return
      end

c  ********************************************************************
c----------------------------------------------------------------------
c  ********************************************************************
c----------------------------------------------------------------------
c     Transf2 changes the current iterate if the unconstrained
c     problem converges to a point which is a stationary one of
c     constrained problem.
c----------------------------------------------------------------------
      subroutine transf2(n,bl,bu,gp,y,x,f,fu,jbound,nfu)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c
c    Input :
c        n : dimension of the problem.
c       bl : vector of lower bounds.
c       bu : vector of upper bounds.
c        y : current iterate of the constarined problem.
c        x : iterate corresponding to y in the unconstrained problem.
c       gp : projected gradient at y.
c       fu : user-supplied function.
c   jbound : see definition in the main routine.
c
c   Output :
c        y : current iterate in the constrained problem.
c        x : current iterate in the unconstrained problem.
c        f : f(y).
c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension y(n),x(n),gp(n),bl(n),bu(n),jbound(n)
      external fu
      dn=dnrm2(n,gp,1)
      alf=1.d1/dn
c----------------------------------------------------------------------
c     Calculate the step along the direction -gp.
c----------------------------------------------------------------------
      do i=1,n
              if(gp(i).gt.0.d0)then

              if(jbound(i).eq.3.or.jbound(i).eq.2)then
                      ci=bl(i)+1.d1*dmax1(dabs(bl(i)),1.d0)
                      bet=0.9d0
                      if(jbound(i).eq.3)ci=bu(i)
                      if(y(i)-bl(i).gt.(ci-bl(i))/1.d4)bet=2.d-1
                      alf=dmin1(alf,dmin1(bet*(y(i)-bl(i))/gp(i),alf))
              else
                      alf=dmin1(alf,1.d-3/dn*dmax1(dabs(y(i)),1.d0))
              end if

        end if

        if(gp(i).lt.0.d0) then

              if(jbound(i).eq.3.or.jbound(i).eq.1)then
                      ci=bu(i)-1.d1*dmax1(dabs(bu(i)),1.d0)
                      bet=0.9d0
                      if(jbound(i).eq.3)ci=bl(i)
                      if(bu(i)-y(i).gt.dabs(bu(i)-ci)/1.d4)bet=2.d-1
                      alf=dmin1(alf,bet*(bu(i)-y(i))/(-gp(i)))
              else
                      alf=dmin1(alf,1.d-3/dn*dmax1(dabs(y(i)),1.d0))
              end if

      end if
      end do
c----------------------------------------------------------------------
c     Define y = y - alf *gp in the constrained problem.
c     Compute x, iterate in the unconstrained problem corresponding
c     to y.
c----------------------------------------------------------------------
      do i=1,n
              if(dabs(gp(i)).gt.0.d0)then
                      coe=1.d0
                      y(i)=y(i)-alf*gp(i)
                      if(jbound(i).eq.3) then
                              if(x(i).lt.0.d0)coe=-1.d0
                              x(i)=coe*dasin(dsqrt((y(i)-bl(i))/
     *            (bu(i)-bl(i))))
                      else
                              if(jbound(i).eq.1)then
                             if(x(i).lt.0.d0)coe=-1.d0
                             x(i)=coe*dsqrt(bu(i)-y(i))
                              else
                             if(jbound(i).eq.2)then
                             if(x(i).lt.0.d0)coe=-1.d0
                             x(i)=coe*dsqrt(y(i)-bl(i))
                                      else
                             x(i)=y(i)
                                      end if
                              end if
                      end if
              end if
      end do
c----------------------------------------------------------------------
c     Compute f(y).
c----------------------------------------------------------------------
      call fu(n,y,f)
      nfu=nfu+1
      return
      end
c--------------------------------------------------------------------
c  ********************************************************************
c----------------------------------------------------------------------
c     Gradx computes the gradient of the transformed problem.
c----------------------------------------------------------------------
      subroutine gradx(n,x,bl,bu,gt,gra,jbound)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input :
c
c         n : number of variables.
c         x : current iterate.
c        bl : vector of lower bounds.
c        bu : vector of upper bounds.
c        gt : gradient of the original problem.
c    jbound : see definition in the main routine.
c
c    Output :
c
c       gra : gradient at x.
c---------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension x(n),gra(n),bl(n),bu(n),gt(n),jbound(n)
      do i=1,n
              gra(i)=gt(i)
c----------------------------------------------------------------------
c     Computes gra(x)=gt(y)*(-2*x), considering the
c     transformation y = bu - x**2 .
c----------------------------------------------------------------------
      if(jbound(i).eq.1)then
              gra(i)=-2.d0*gt(i)*x(i)
      else
c----------------------------------------------------------------------
c     Computes gra(x)=gt(y)*(2*x), considering the
c     transformation y = bl + x**2
c----------------------------------------------------------------------
              if(jbound(i).eq.2)then
                      gra(i)=2.d0*gt(i)*x(i)
              else
c----------------------------------------------------------------------
c     Computes gra(x)=gt(y)*(bu-bl)*sin(2*x), considering the
c     transformation y = bl + (bu - bl) * (sin x)**2.
c----------------------------------------------------------------------
                      if(jbound(i).eq.3)then
                              bl1=bu(i)-bl(i)
                              gra(i)=gt(i)*bl1*dsin(2.d0*x(i))
                      end if
              end if
      end if

      end do

      return
      end
c  ********************************************************************
c----------------------------------------------------------------------
c     Hessix computes the Hessian of the transformed problem.
c----------------------------------------------------------------------
      subroutine hessix(n,x,bl,bu,gy,hes,jbound)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c    Input :
c
c        n :  number of variables.
c        x :  current iterate.
c       bl :  vector of lower bounds.
c       bu :  vector of upper bounds.
c       gy :  gradient of the original problem.
c      hes :  vector of dimension n1 = n*(n+1)/2 containing the upper half
c             of the Hessian of the original problem stored columnwise.
c   jbound :  see definition in the main routine.
c
c   Output :
c
c      hes :  Hessian at x.
c-----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension x(n),hes(1),bl(n),bu(n),gy(n),jbound(n)
c-----------------------------------------------------------------------
c      Compute the Hessian in the new variables.
c-----------------------------------------------------------------------
      do i=1,n
              xi=x(i)
              i1=i*(i+1)/2
              i2=i1
              k1=i*(i-1)/2+1
              k2=i2-1
              if(jbound(i).eq.1)then
                      hes(i1)=hes(i1)*4.d0*xi**2-2.d0*gy(i)
                      do k=i,n-1
                              i2=i2+k
                              hes(i2)=hes(i2)*(-2.d0*xi)
                      end do
                      do k=k1,k2
                              hes(k)=hes(k)*(-2.d0*xi)
                      end do
              else
                      if(jbound(i).eq.2) then
                              hes(i1)=hes(i1)*4.d0*xi**2+2.d0*gy(i)

                              do k=i,n-1
                                      i2=i2+k
                                      hes(i2)= hes(i2)*2.d0*xi
                              end do

                              do k=k1,k2
                                      hes(k)= hes(k)*2.d0*xi
                              end do
                      else
                              if(jbound(i).eq.3)then
                                      bul=bu(i)-bl(i)
                                      hes(i1)=hes(i1)*(2.d0*bul*
     *           dsin(xi)*dcos(xi))**2+
     *                                2.d0*gy(i)*bul*dcos(2.d0*xi)

                                      do k=i,n-1
                                              i2=i2+k
                                              hes(i2)= hes(i2)*bul*
     *                   dsin(2.d0*xi)
                                      end do

                                      do k=k1,k2
                                              hes(k)= hes(k)*bul*
     *                   dsin(2.d0*xi)
                                      end do

                                      end if
                      end if
              end if
      end do
      return
      end
c  ********************************************************************
c-------------------------------------------------------------------------
c     Subroutine for computing the Householder decomposition
c     of the Hessian matrix H= Qt*T*Q at the current iterate.
c----------------------------------------------------------------------
      subroutine factor(n,n1,hes,qt,d,e,itrid)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c         n:  dimension of the problem.
c        n1:  n*(n+1)/2
c       hes:  vector of dimension n1 containing the upper
c             half of the Hessian stored columnwise.
c     itrid:  parameter such that if equal to
c             0 the Hessian is not a tridiagonal matrix.
c             1 the Hessian is a tridiagonal matrix.
c
c    Output:
c
c        Qt:  orthogonal matrix of the decomposition Qt*T*Q.
c         d:  diagonal of the tridiagonal matrix T.
c         e:  subdiagonal of the tridiagonal matrix T.
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension hes(n1),qt(n,n),d(n),e(n)

      do j=1,n

              do i=1,n
                      qt(i,j)=0.d0
              end do

              qt(j,j)=1.d0
      end do

      if(itrid.eq.1)then
              e(1)=0.d0
              d(1)=hes(1)

              if(n.ge.2)then
                      kd=3
                      do i=2,n
                              e(i)=hes(kd-1)
                              d(i)=hes(kd)
                              kd=kd+i+1
                      end do
              end if

      else
c----------------------------------------------------------------------
c      Call to the subroutine which computes the Householder
c      decomposition
c----------------------------------------------------------------------
      call dholder(hes,n,n1,d,e)
c----------------------------------------------------------------------
c     Find the orthogonal matrix qt ,product of the
c     Householder transformations.
c----------------------------------------------------------------------
      if(n.gt.1)then
              do i=2,n
                      l= i-1
                      ia=(i*l)/2
                      h=hes(ia+i)
                      if(dabs(h).gt.0.d0)then
                              do j=1,n
                                      s=0.0d0
                                      do k=1,l
                                             s=s+hes(ia+k)*qt(k,j)
                                      end do
                                      s=s/h
                                      do k=1,l
                                           qt(k,j)=qt(k,j)-s*hes(ia+k)
                                      end do
                              end do
                      end if
              end do
      end if
      end if
      return
      end
c  ********************************************************************
c-----------------------------------------------------------------------
c  ********************************************************************
c----------------------------------------------------------------------
c     Subroutine dholder finds the tridiagonal matrix T of
c     decomposition Qt*T*Q, where Qt is an orthogonal matrix
c     using Householder's transformations.
c----------------------------------------------------------------------
      subroutine dholder (a,n,n1,d,e)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c    Input :
c
c        a :  is a vector of dimension n1 = n*(n+1)/2
c             containing the upper half of the symmetric matrix
c             stored columnwise.
c
c        n :  dimension of the problem.
c
c       n1 :  dimension of vector a.
c
c   Output :
c
c        d :  diagonal of the tridiagonal matrix.
c
c        e :  subdiagonal of the tridiagonal matrix.
c
c        a :  the vector a restores information
c             for computing Qt from Householder transformations.
c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension a(n1),d(n),e(n)
      data zero/0.d0/
      m=n1-1
      nq=n1-n

      do it=1,n
              ib=n+1-it
              l=ib-1
              s=zero
              sum = zero

              if(l.lt.1)then
                      e(ib)=zero
                      go to 20
              end if

              nk=m

              do k=1,l
                      sum=sum+dabs(a(nk))
                      nk=nk-1
              end do

              if(sum.gt.zero) then
                      nk=m

                      do k=1,l
                              a(nk)=a(nk)/sum
                              s=s+a(nk)*a(nk)
                              nk=nk-1
                      end do

                      fr=a(m)
                      gr=-dsign(dsqrt(s),fr)
                      e(ib)=sum*gr
                      s=s-fr*gr
                      a(m)=fr-gr
                      if(l.eq.1) go to 10
                      fr=zero
                      kl1=1

                      do k=1,l
                              gr=zero
                              ik=nq+1
                              kk=kl1
c----------------------------------------------------------------------
c     Form element of a*u.
c----------------------------------------------------------------------
                      do kl=1,k
                              gr=gr+a(kk)*a(ik)
                              kk=kk+1
                              ik=ik+1
                      end do
                              kp1=k+1

                              if(l.ge.kp1)then
                                      kk=kk+k-1
                                      do kl=kp1,l
                                              gr=gr+a(kk)*a(ik)
                                              kk=kk+kl
                                              ik = ik+1
                                      end do
                              end if
c----------------------------------------------------------------------
c     Form element of p.
c----------------------------------------------------------------------
                              e(k)=gr/s
                              fr=fr+e(k)*a(nq+k)
                              kl1=kl1+k
                      end do

                      ss=fr/(s+s)
c---------------------------------------------------------------------
c     Form reduced a.
c----------------------------------------------------------------------
                      kk=1

              do k=1,l
                      fr=a(nq+k)
                      gr=e(k)-ss*fr
                      e(k)=gr

                      do kl=1,k
                              a(kk)=a(kk)-fr*e(kl)-gr*a(nq+kl)
                              kk=kk+1
                      end do

              end do

10            do kl=1,l
                      a(nq+kl)=a(nq+kl)*sum
              end do

              else
                      e(ib)=zero
              end if

20            d(ib)=a(nq+ib)
              a(nq+ib)=s*sum*sum
              nq=nq-ib+1
              m=m-ib
      end do

      return
      end
c *********************************************************************
c----------------------------------------------------------------------
c     Subroutine tri1 solves linear systems with
c     positive definite symmetric tridiagonal matrices.
c----------------------------------------------------------------------
      subroutine tri1(n,d,e,b)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c    Input :
c
c        n :  order of the tridiagonal matrix.
c        d :  diagonal of the tridiagonal matrix.
c        e :  off-diagonal of the tridiagonal matrix.
c        b :  the right hand side vector.
c----------------------------------------------------------------------
c   Output :
c
c        b :  contains the solution.
c
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension d(n),e(n),b(n)
c----------------------------------------------------------------------
c      check n=1 case.
c----------------------------------------------------------------------
      if(n.eq.1)then
              b(1)=b(1)/d(1)
              go to 70
      end if

      nm1=n-1
      nm1d2=nm1/2

      if(n.gt.2)then
              kbm1= n-1
c----------------------------------------------------------------------
c     zero top half of subdiagonal and bottom half of superdiagonal.
c----------------------------------------------------------------------
              do k=1,nm1d2
                      t1=e(k)/d(k)
                      d(k+1)=d(k+1)-t1*e(k)
                      b(k+1)=b(k+1)- t1*b(k)
                      t2=e(kbm1)/d(kbm1+1)
                      d(kbm1)=d(kbm1)- t2*e(kbm1)
                      b(kbm1)=b(kbm1)- t2*b(kbm1+1)
                      kbm1=kbm1-1
              end do

      end if

      kp1=nm1d2+1
c----------------------------------------------------------------------
c     Clean up for possible 2 x 2 block at center.
c----------------------------------------------------------------------
      if(mod(n,2).eq.0) then
              t1= e(kp1)/d(kp1)
              d(kp1+1)=d(kp1+1)-t1*e(kp1)
              b(kp1+1)=b(kp1+1)-t1*b(kp1)
              kp1=kp1+1
      end if
c----------------------------------------------------------------------
c     Back solve starting at the center, going towards the top
c     and bottom.
c----------------------------------------------------------------------
      b(kp1)=b(kp1)/d(kp1)

      if(n.gt.2) then
              k=kp1-1
              ke= kp1+nm1d2 -1
              do kf=kp1,ke
                      b(k)=(b(k)-e(k)*b(k+1))/d(k)
                      b(kf+1)=(b(kf+1)-e(kf)*b(kf))/d(kf+1)
                      k=k-1
              end do
      end if

      if(mod(n,2).eq.0)b(1)=(b(1)-e(1)*b(2))/d(1)
70    return
      end
c  ********************************************************************
c----------------------------------------------------------------------
c     Computes either Ax or A'x where A is a matrix, A' its transpose,
c     and x a vector.
c----------------------------------------------------------------------
      subroutine matmul(n,a,x,ind,y)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c        n :   dimension of the problem
c        a :   nxn matrix
c        x :   n-dimensional vector
c      ind :   if equal to 1 computes Ax
c              if equal to 2 computes A'x
c
c    Output:
c
c        y :   the product as defined by the input parameter ind
c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension a(n,n), x(n),y(n)
      go to (10,20)ind

10    do i=1,n
              yi=0.d0

              do j=1,n
                      yi=yi+ a(i,j)*x(j)
              end do

              y(i)=yi
      end do

      go to 30

20    do j=1,n
              yj=0.d0

              do i=1,n
                      yj=yj+a(i,j)*x(i)
              end do

              y(j)=yj
      end do

30    return
      end
c  ********************************************************************
c----------------------------------------------------------------------
c     This subroutine prints the results
c----------------------------------------------------------------------
      subroutine res(n,x,g,vf,nfu,ngr,nh,nit,ier,ibound)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c    Input :
c
c        n :   dimension of the problem
c        x :   best obtained point
c        g :   gradient at x in unconstrained problems.
c              projected gradient at x in constrained problems.
c       vf :   f(x).
c      nfu :   total number of function evaluations.
c      ngr :   total number of gradiente evaluations.
c       nh :   total number of Hessian evaluations.
c      nit :   number of iterations.
c      ier :   0 convergence has been achieved.
c              1 maximum number of function evaluations exceeded.
c              2 failure to converge.
c              3 wrong input in a constrained problem.
c   ibound :   see definition in the main routine.

c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension x(n),g(n)

      if(ier.eq.3)then
              write(6,1)
1             format(10(/),
     *' * * * INPUT ERROR IN A CONSTRAINED PROBLEM - STOP * * *',/)
              return
      end if

      do i=1,n
              write(6,10)i,x(i)
              if(mod(i,20).eq.0)pause
      end do

      dnq=dnrm2(n,g,1)
      pause
      write(6,20)n
      write(6,30) vf
      if(ibound.eq.0)write(6,40)dnq
      if(ibound.ne.0)write(6,50)dnq
      write(6,60) nit
      write(6,70) nfu
      if(ngr.ne.0)write(6,80) ngr
      if(nh.ne.0)write(6,90) nh
      write(6,100) ier
      write(6,110)
10    format('   x(',i3,') =',d16.8)
20    format(20(/),10x,9(' -'),' Final results',9(' -'),
     *///,10x,
     *       '   Number of variables              :',i6)
30    format(10x,'   Final function value             :',d11.4)
40    format(10x,'   Norm of the gradient             :',d11.4)
50    format(10x,'   Norm of the projected gradient   :',d11.4)
60    format(10x,'   Number of iterations             :',i6)
70    format(10x,'   Number of function evaluations   :',i6)
80    format(10x,'   Number of gradient evaluations   :',i6)
90    format(10x,'   Number of Hessian evaluations    :',i6)
100   format(10x,'   ier                              :',i6)
110   format(///,10x,26(' -'),//)
      pause
      return
      end

c  ********************************************************************
c----------------------------------------------------------------------
c     Subroutine autova computes the least eigenvalue of
c     the tridiagonal matrix Tk.
c     In case of failure it returns the lowest Gerschgorin bound.
c----------------------------------------------------------------------
      subroutine autova(d,e2,n)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c    Input :
c
c        d :  diagonal of the tridiagonal matrix.
c       e2 :  vector containing the squares of the subdiagonal elements.
c        n :  dimension of the problem.
c
c   Output :
c
c     d(1) :  estimation of the least eigenvalue.
c
c  Warning :  vectors d and e2 are destroyed.
c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension d(n),e2(n)
      data tol/0.10842022d-18/,zero/0.d0/
      dlam = zero
      s = zero
c----------------------------------------------------------------------
c     Look for small sub-diagonal entries
c     Define initial shift from lower Gerschgorin bound
c----------------------------------------------------------------------
      e2(1)=zero

      if(n.ge.2)then
              re2=dsqrt(e2(2))
              ush=d(1)-re2

              if(n.gt.2)then
                      do i=2,n-1
                              p=re2
                              if(p.le.tol*(dabs(d(i))+dabs(d(i-1))))
     *            e2(i)=zero
                              re2=dsqrt(e2(i+1))
                              ush=dmin1(d(i)-p-re2,ush)
                      end do
              end if

              if(re2.le.tol*(dabs(d(n))+dabs(d(n-1))))e2(n)=zero
              ush=dmin1(d(n)-re2,ush)
              autov=ush

              do i=1,n
                      d(i)=d(i)-ush
              end do
c----------------------------------------------------------------------
c     QR transformation
c----------------------------------------------------------------------
              delta=d(n)
10            i=n
              f=dabs(tol*ush)
              dlam=dmax1(dlam,f)
              if(delta.le.dlam)go to 20
c----------------------------------------------------------------------
c     Set small sub-diagonal squares to zero
c     for reducing effects of underflows.
c----------------------------------------------------------------------
              do j=2,n
                      if(e2(j).le.(tol*(d(j)+d(j-1)))**2)e2(j)=zero
              end do

              f=e2(n)/delta
              qp=delta+f
              p=1.d0
              k1=n-1

              do ii=1,k1
                      i=n-ii
                      q=d(i)-s-f
                      r=q/qp
                      p=p*r+1.d0
                      ep=f*r
                      d(i+1)=qp+ep
                      delta=q-ep
                      if(delta.le.dlam) go to 20
                      f=e2(i)/q
                      qp=delta+f
                      e2(i+1)=qp*ep
              end do

              d(1)=qp
              s=qp/p
              ush=ush+s
              delta=d(n)-s
              if(s.gt.zero)go to 10
c----------------------------------------------------------------------
c     Return with an estimation of the least eigenvalue.
c----------------------------------------------------------------------
              e2(1)=1
              d(1)=autov
              go to 30
c----------------------------------------------------------------------
c     Convergence.
c----------------------------------------------------------------------
20            d(1)=ush
      end if

30    return
      end
c********************************************************************
c----------------------------------------------------------------------
c     The subroutine funct computes the value of the objective
c     function on the Levenberg-Marquardt curve at the point x1.
c----------------------------------------------------------------------
      subroutine funct(fcn,n,x0,bl,bu,d,e,qt,w,al,f,x1,y,qs,wa,
     *                  ibound,jbound,nfu)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c       fcn:  external function defining the objective function.
c         n:  dimension of the problem.
c        x0:  starting point on the Levenberg-Marquardt curve
c        bl:  vector of lower bounds.
c        bu:  vector of upper bounds.
c  d, e, qt:  corresponding to the Householder factorization
c         w:  vector Q*(-grad(x0))
c        al:  'Levenberg-Marquardt' parameter.
c        wa:  working vector
c    ibound:  see definition in the main routine.
c    jbound:  see definition in the main routine.
c
c    Output:
c
c       x1 :  point on the curve: x0+s(al)
c        f :  f(x1)
c        y :  coordinates of x1 in the original problem.
c       qs :  vector Q*s(al)
c----------------------------------------------------------------------
      implicit real*8 (a-h,o-z)
      dimension x0(n),d(n),e(n),qt(n,n),w(n),qs(n),wa(1),x1(n),
     *          y(n),bl(n),bu(n),jbound(n)
      external fcn
      nar=1
      nt1=0
      nt2=nt1+n
c----------------------------------------------------------------------
c     Set the parameters for tri1
c----------------------------------------------------------------------
      do i=1,n-1
              wa(nt1+i)=e(i+1)
              wa(nt2+i)=d(i)+al
              qs(i)=w(i)
      end do
      wa(nt1+n)=0.d0
      wa(nt2+n)=d(n)+al
      qs(n)=w(n)
c----------------------------------------------------------------------
c     Solve the system ( T+al*In)Q*s(al) = -Q*grad(x0)
c     Find the coordinates of x1 = x0+s(al).
c----------------------------------------------------------------------
      call tri1(n,wa(nt2+1),wa(nt1+1),qs)
      do i=1,n
              sx=0.d0
              do j=1,n
                      sx=sx+qt(i,j)*qs(j)
              end do
              x1(i)=x0(i)+sx
      end do
c----------------------------------------------------------------------
c     Compute f(x1)
c----------------------------------------------------------------------
      if(ibound.eq.0)then
              call fcn(n,x1,f)
      else
              call transf(n,nar,y,bl,bu,2,x1,jbound,ier)
              call fcn(n,y,f)
      end if
      nfu=nfu+1
      return
      end
c  ********************************************************************
c----------------------------------------------------------------------
c     Function ddot computes the inner product of vectors sx,sy
c     This is a version compatible with BLAS
c----------------------------------------------------------------------
      double precision function ddot (n,x,ix,y,iy)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c        n :  length of vectors x and y.
c        x :  vector of lenght max(n*iabs(ix),1).
c       ix :  displacement between elements of x.
c             x(i) is defined as
c             x(1+(i-1)*ix) if ix.ge.0 or
c             x(1+(i-n)*ix) if ix.lt.0.
c        y :  vector of lenght max(n*iabs(iy),1).
c       iy :  displacement between elements of y.
c             y(i) is defined as
c             y(1+(i-1)*iy) if iy.ge.0 or
c             y(1+(i-n)*iy) if iy.lt.0.
c
c    Output:
c
c      ddot:  inner product of vectors x,y
c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension x(n),y(n)
      ddot=0.d0
      if(n.le.0)return
      if(ix.eq.iy)if(ix-1)10,20,40
10    ix=1
      iy=1
      if(ix.lt.0)ix=(-n+1)*ix+1
      if(iy.lt.0)iy=(-n+1)*iy+1

      do i=1,n
              ddot = ddot+x(ix)*y(iy)
              ix=ix+ix
              iy = iy+iy
      end do

      return
20    m=n-(n/5)*5
      if(m.eq.0)go to 30

      do i=1,m
              ddot=ddot+x(i)*y(i)
      end do

      if(n.lt.5)return
30    mp1=m+1

      do i=mp1,n,5
              ddot = ddot+x(i)*y(i)+x(i+1)*y(i+1)+x(i+2)*y(i+2)
     *              +x(i+3)*y(i+3)+x(i+4)*y(i+4)
      end do

      return
40    ns = n*ix

      do i=1,ns,ix
              ddot = ddot+x(i)*y(i)
      end do

      return
      end
c  ********************************************************************
c----------------------------------------------------------------------
c     This is a version of the standard BLAS routine for
c     computing the euclidean norm of vector x
c----------------------------------------------------------------------
      double precision function dnrm2(n,x,incx)
c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c     Input:
c
c        n :   dimension of the problem
c        x :   n-dimensional vector
c     incx :   displacement between elements of x (normally 1)
c
c    Output:
c
c     dnrm2:  //x// = dsqrt(x(1)**2 + ... + x(n)**2)
c----------------------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension x(N)
      data zero/0.d0/,one/1.d0/
c----------------------------------------------------------------------
c     The following values of bound1 and bound2 are for computers
c     implementing the IEEE floating point standard. For older
c     architectures those values must be replaced by
c     data bound1/8.232d-11/,bound2 /1.304d19/
c----------------------------------------------------------------------
      data bound1/3.861d-41/,bound2 /9.737d76/
      if(n.gt.0)go to 10
      dnrm2 = zero
      go to 130
10    assign 30 to next
      s= zero
      nx=n*incx
      i=1
20    go to next, (30,40,70,80)
30    if(dabs(x(i)).gt.bound1)go to 110
      assign 40 to next
      xmax = zero
40    if(dabs(x(i)).gt.zero) go to 42
      go to 120
42    if(dabs(x(i)).gt.bound1) go to 110
      assign 70 to next
      go to 60
50    i=j
      assign 80 to next
      s=(s/x(i))/x(i)
60    xmax=dabs(x(i))
      go to 90
70    if (dabs(x(i)).gt.bound1) go to 100
80    if (dabs(x(i)).le.xmax) go to 90
      s=one+s*(xmax/x(i))**2
      xmax=dabs(x(i))
      go to 120
90    s=s+(x(i)/xmax)**2
      go to 120
100   s=(s*xmax)*xmax
110   bound3=bound2/float(n)

      do j=1,nx,incx
              if(dabs(x(j)).ge.bound3) go to 50
              s=s+x(j)**2
      end do

      dnrm2=dsqrt(s)
      go to 130
120   continue
      i=i+incx
      if(i.le.nx)go to 20
      dnrm2=xmax*dsqrt(s)
130   continue
      return
      end
c  ********************************************************************
c----------------------------------------------------------------------
c     This subroutine prints the results to the file specified in file name
c----------------------------------------------------------------------
      subroutine prntout (fu,n,x0,fopt,eps,ibound,
     *           jbound,bl,bu,wa,nfu,ngr, nh, nit,ier, ichoice, flname)

C !ms$attributes DLLEXPORT :: prntout

c----------------------------------------------------------------------
c                       Arguments
c                       ---------
c    Input :
c
c     All input arguments are described in curvi_ in more detail, except for
c     ichoice and flname.
c
c      fu     :   external function just as specified in curvi_
c      n      :   dimension of the problem
c      x0     :   initial value into curvi_ if ichoice = 1
c                 or best obtained point    if ichoice = 0
c     fopt    :   best value found by curvi_
c
c     eps     :  requested tolerance
c     ibound  :  0/1 variable determining if bounds are active
c     jbound  :  specific information on individual bounds
c     bl      :  Lower bounds
c     bu      :  Upper bounds
c     wa      :  Work vector returned from and passed into curvi_
c     nfu     :  Number of function values
c     ngr     :  Number of gradient values (set to 0 if ichoice = 0)
c     nh      :  Number of hessian values  (set to 0 if ichoice = 0)
c     nit     :  Number of iterations      (set to 0 if ichoice = 0)
c     ier     :  error criteria
c                0 convergence has been achieved.
c                1 maximum number of function evaluations exceeded.
c                2 failure to converge.
c                3 wrong input in a constrained problem.
c    ichoice  :  ichoice is 0 or 1.  Choose 0 if it is to be invoked before
c                a call to the routine and 1 if after a call.
c
c   flname    :  The output file name
c

c----------------------------------------------------------------------
      implicit none

      double precision x0(*), wa(*), bl(*), bu(*)
      double precision temp, eps, fopt, dnrm2, dnq
      integer   ibound, jbound(*), error, nh, i
      integer nfu, ngr, nit, ier, ichoice, n, lwa
      character flname*(*)
      external fu

      error = 0

      if (ichoice .eq. 0) then
      open(26, file = flname)


      write(26, *) 'The initial input for Curvi follows  '

      write(26, *) ' '
      write(26, *) ' '
      lwa = 9*n+n*(n+1)/2+n*n+max(7*n-n*(n+1)/2,0)
      write(26, *) 'Length of working array wa must be at least ', lwa
      if ( nfu .eq. 0) then
          write(26, *) 'Default bound on number of function values  ',
     *                    n*5000 , '   for curvif'
          write(26, *) '                                            ',
     *                    n*1000 , '   for curvig'
          write(26, *) '                                            ',
     *                    n*1000 , '   for curvih'
      else
          write(26, *) 'Bound on number of function values  ', nfu
      endif

      write(26, *) 'Error tolerance  ', eps
      write(26, *) 'Ibound           ', ibound

c         write input information for debugging purposes
c         and for problem preservations

      If( ibound .eq. 0 ) then
c
c         Initialize variables nh, ngr, nit
c
      nh  = 0
      ngr = 0
      nit = 0

      write(26, *) 'There are no bounds on the variables since '
      write(26, *)   'Ibound = 0'
      write(26, *) ' '
      write(26, *) 'The initial projected values'
      write(26, *) ' '
      do i = 1,n
          write(26,1017) i, x0(i)
      enddo
      call fu(n,x0,temp)
      write(26, 1011)
      write(26, *) 'The initial function value is  '
      write(26, 1011)
      write(26, 1020) temp
      write(26, 1011)
      write(26, 1011)

      else


      write(26, 1011)
      write(26, 1010)
      write(26, 1011)

      do i = 1, n
          wa(i) = x0(i)
          if( jbound(i) .eq. 3) then
              write(26, 1012) i, x0(i), bl(i), bu(i), jbound(i)
              if(bl(i) .gt. bu(i) ) then
                  write(26,*) 'The above constraint is inconsistent'
                  error = 1
                  write(26,1011)
               else
                  if (wa(i) .lt. bl(i))  wa(i) = bl(i)
                  if (wa(i) .gt. bu(i))  wa(i) = bu(i)
              endif
          else if( jbound(i) .eq. 2) then
              write(26, 1013) i, x0(i), bl(i), jbound(i)
              if (wa(i) .lt. bl(i))  wa(i) = bl(i)

          else if (jbound(i) .eq. 1) then
              write(26, 1014) i, x0(i), bu(i), jbound(i)
              if (wa(i) .gt. bu(i))  wa(i) = bu(i)

          else if (jbound(i) .eq. 0) then
              write(26, 1015) i, x0(i), jbound(i)
          else
              write(26, 1016) i, x0(i), jbound(i)
              write(26, *) 'This is an undefined condition '
              error = 1
          endif
      enddo

      if (error .eq. 0) then
          call fu(n,wa,temp)
          write(26, 1011)
          write(26, *)  'The initial function value at the projected ini
     *tial point is'

          write(26, 1011)
          write(26, 1020) temp
          write(26, 1011)
          write(26, 1011)
      else
          write(26, *) 'The conditions specified are inconsistent or und
     *efined'
      endif

      endif
      close(26)
      return

      endif
      open(26, access = 'append', file = flname)
      write(26, 1011)
      write(26, *) '************  Output from CURVI  ************'
      write(26, 1011)

1010  format(10x, ' No. ', 10x, 'Initial Value', 10x,
     * 'Lower Bound', 10x, 'Upper Bound', 10x, 'Jbound')
1011  format(' ')
1012  format(10x, i5, 10x, g16.8, 5x,
     * g16.8, 5x, g16.8, 5x, i4)

1013  format(10x, i5, 10x, g16.8, 5x,
     *    g16.8, 26x, i4)

1014  format(10x, i5, 10x, g16.8, 21x,
     *   5x, g16.8, 5x, i4)

1015  format(10x, i5, 10x, g16.8, 5x,
     * 16x, 5x, 16x, 5x, i4)

1016  format(10x, i5, 10x, g16.8, 5x,
     * 14x, '??', 5x, 14x, '??', 5x, i4)

1017  format(10x, i5, 10x, g16.8, 5x,
     * 16x, 5x, 16x, 5x)

1020  format(10x, g16.8)

      if(ier.eq.3)then
              write(26,1)
1             format(10(/),
     *' * * * INPUT ERROR IN A CONSTRAINED PROBLEM - STOP * * *',/)
              return
      end if

c         write output assuming ier < 3
      write(26, 1000)
      write(26, 1001)
      do i=1,n
              write(26,10)i,x0(i)

      end do

      dnq=dnrm2(n,wa(n*n + n +1),1)

      write(26,20)n
      write(26,30) fopt
      if(ibound.eq.0)write(26,40)dnq
      if(ibound.ne.0)write(26,50)dnq
      write(26,60) nit
      write(26,70) nfu
      if(ngr.ne.0)write(26,80) ngr
      if(nh.ne.0)write(26,90) nh
      write(26,100) ier
      write(26,110)
10    format(10x, i5, 10x, g16.8, 10x, g16.8)
20    format(5(/),10x,9(' -'),' Final Summary',9(' -'),
     *///,10x,
     *       '   Number of variables              :',i6)
30    format(10x,'   Final function value             :',d11.4)
40    format(10x,'   Norm of the gradient             :',d11.4)
50    format(10x,'   Norm of the projected gradient   :',d11.4)
60    format(10x,'   Number of iterations             :',i6)
70    format(10x,'   Number of function evaluations   :',i6)
80    format(10x,'   Number of gradient evaluations   :',i6)
90    format(10x,'   Number of Hessian evaluations    :',i6)
100   format(10x,'   ier                              :',i6)
110   format(///,10x,26(' -'),//)
1000  format(10x, ' No. ', 10x, 'Final Value')
1001  format(10x, '_____', 10x, '___________')



      close(26)
      return
      end

subroutine curvif_simplified(x0, obj_func, lower_bounds, upper_bounds, epsilon, n, x_opt, f_opt)
    ! Declarations
    implicit none
    integer, intent(in) :: n
    double precision :: epsilon, wa(9*n+n*(n+1)/2+n*n+max(7*n-n*(n+1)/2,0))
!    double precision :: fopt_tmp
    double precision, intent(in) :: x0(n), lower_bounds(n), upper_bounds(n)
    double precision, intent(out) :: f_opt, x_opt(n)
    integer :: i, ibound, nfu, idiff, kmax, jbound(n), nit, ier
    external obj_func, curvif

    ! Initialize CURVI inputs that are used with the same value for every test
!    epsilon=1.d-10! tolerance for the stopping criterion.
    ibound=1      ! 1 if constrained problem
    nfu=0         ! max number of calls to fu
    idiff=2       ! idiff = 2  central differences
    kmax=3        ! hessian is recomputed after kmax iterations
    DO i=1,n
        jbound(i)=3      ! 3 if the ith variable has both upper and lower bounds
    end do
    call curvif(obj_func, &
     n,                   &
     x0,                  &
     f_opt,               &
     epsilon,             &
     ibound,              &
     jbound,              &
     lower_bounds,        &
     upper_bounds,        &
     wa,                  &
     nfu,                 &
     nit,                 &
     idiff,               &
     kmax,                &
     ier)
    do i = 1, n
        x_opt(i) = x0(i)
    end do
end

subroutine readTest(file_path)
  use testData
  implicit none
  CHARACTER(LEN=500) :: file_path
  integer file_id,stat,i,wa_length

  ! Initialize IO id and file
  file_id=2
  open(file_id,file=file_path)
  ! Read number of params
  call assertNextVarInFileIs(file_id,"nparams")
  read(file_id,*, iostat=stat) nparams
  if (stat /= 0) call exitWithError("Error reading value of nparams into memory")
  ! Allocate all structures that depend on number of params
  allocate(params_names(nparams))
  allocate(params_values(nparams))
  allocate(bl(nparams))
  allocate(bu(nparams))
  allocate(jbound(nparams))
  wa_length = 9*nparams+nparams*(nparams+1)/2+nparams*nparams+max(7*nparams-nparams*(nparams+1)/2,0)
  allocate(wa(wa_length))
  ! Continue reading the file
  call assertNextVarInFileIs(file_id,"params_names")
  read(file_id,*, iostat=stat) (params_names(i), i = 1, nparams)
  if (stat /= 0) call exitWithError("Error reading value of params_names into memory")

  call assertNextVarInFileIs(file_id,"params_values")
  read(file_id,*, iostat=stat) (params_values(i), i = 1, nparams)
  if (stat /= 0) call exitWithError("Error reading value of params_values into memory")

  call assertNextVarInFileIs(file_id,"lower_bounds")
  read(file_id,*, iostat=stat) (bl(i), i = 1, nparams)
  if (stat /= 0) call exitWithError("Error reading value of lower_bounds into memory")

  call assertNextVarInFileIs(file_id,"upper_bounds")
  read(file_id,*, iostat=stat) (bu(i), i = 1, nparams)
  if (stat /= 0) call exitWithError("Error reading value of upper_bounds into memory")

  call assertNextVarInFileIs(file_id,"stopTime")
  read(file_id,*, iostat=stat) stopTime
  if (stat /= 0) call exitWithError("Error reading value of stopTime into memory")

  call assertNextVarInFileIs(file_id,"ntarget_vars")
  read(file_id,*, iostat=stat) ntarget_vars
  if (stat /= 0) call exitWithError("Error reading value of ntarget_vars into memory")

  call assertNextVarInFileIs(file_id,"target_vars")
  ! Allocate target vars array
  allocate(target_vars(ntarget_vars))
  ! Read target_vars into array
  read(file_id,*, iostat=stat) (target_vars(i), i = 1, ntarget_vars)
  ! We finished reading the file, so we expect an end of file. If the file continues, exit with error
  if (stat /= 0) call exitWithError("Error reading value of target_vars into memory")

end subroutine readTest

subroutine exitWithError(error_str)
  implicit none
  CHARACTER(LEN=*) :: error_str
    write(*,*) "  ERROR! Invalid config file. Stopping. ", error_str
    STOP
end subroutine exitWithError

subroutine assertNextVarInFileIs(file_id,expected_var)
  implicit none
  CHARACTER(LEN=*) :: expected_var
  CHARACTER(LEN=30) :: VAR_NAME
  integer file_id,stat
  read(file_id,"(A)", iostat=stat) VAR_NAME
  write(*,*) "Reading ", VAR_NAME
  if (stat /= 0) call exitWithError("Error trying to read the name of expected var " // expected_var // " into memory")
  IF(VAR_NAME.NE.expected_var) call exitWithError("Tried to read variable " // expected_var // " bot got var " // VAR_NAME // " instead.")
end subroutine assertNextVarInFileIs
